# Predefined Constants

The constants below are defined by this extension, and will only be available when the extension has either been compiled into PHP or dynamically loaded at runtime.

Descriptions and uses for these constants are described within the curl_setopt(), curl_multi_setopt() and curl_getinfo() documentation.

Constants | Description
--- | ---
`CURLALTSVC_H1` (int) | Available as of PHP 8.2.0 and cURL 7.64.1.
`CURLALTSVC_H2` (int) | Available as of PHP 8.2.0 and cURL 7.64.1.
`CURLALTSVC_H3` (int) | Available as of PHP 8.2.0 and cURL 7.64.1.
`CURLALTSVC_READONLYFILE` (int) | Available as of PHP 8.2.0 and cURL 7.64.1.
`CURLAUTH_ANY` (int) |
`CURLAUTH_ANYSAFE` (int) |
`CURLAUTH_AWS_SIGV4` (int) | Available as of PHP 8.2.0 and cURL 7.75.0.
`CURLAUTH_BASIC` (int) |
`CURLAUTH_BEARER` (int) | Available as of PHP 7.3.0 and cURL 7.61.0.
`CURLAUTH_DIGEST` (int) |
`CURLAUTH_DIGEST_IE` (int) | Use HTTP Digest authentication with an IE flavor. Available as of cURL 7.19.3.
`CURLAUTH_GSSAPI` (int) | Available as of PHP 7.3.0 and cURL 7.54.1
`CURLAUTH_GSSNEGOTIATE` (int) |
`CURLAUTH_NEGOTIATE` (int) | Available as of PHP 7.0.7 and cURL 7.38.0.
`CURLAUTH_NONE` (int) | Available as of cURL 7.10.6.
`CURLAUTH_NTLM` (int) |
`CURLAUTH_NTLM_WB` (int) | Available as of PHP 7.0.7 and cURL 7.22.0
`CURLAUTH_ONLY` (int) | This is a meta symbol. OR this value together with a single specific auth value to force libcurl to probe for unrestricted auth and if not, only that single auth algorithm is acceptable. Available as of cURL 7.21.3.
`CURLFTPAUTH_DEFAULT` (int) |
`CURLFTPAUTH_SSL` (int) |
`CURLFTPAUTH_TLS` (int) |
`CURLFTPMETHOD_DEFAULT` (int) | Available as of PHP 8.2.0 and cURL 7.15.3.
`CURLFTPMETHOD_MULTICWD` (int) | Do a single `CWD` operation for each path part in the given URL. Available as of cURL 7.15.3.
`CURLFTPMETHOD_NOCWD` (int) | libcurl makes no `CWD` at all. libcurl does `SIZE`, `RETR`, `STOR` etc. and gives a full path to the server for all these commands. Available as of cURL 7.15.3.
`CURLFTPMETHOD_SINGLECWD` (int) | libcurl does one `CWD` with the full target directory and then operates on the file like in the multicwd case. Available as of cURL 7.15.3.
`CURLFTPSSL_ALL` (int) |
`CURLFTPSSL_CCC_ACTIVE` (int) | Initiate the shutdown and wait for a reply. Available as of cURL 7.16.2.
`CURLFTPSSL_CCC_NONE` (int) | Do not attempt to use CCC (Clear Command Channel). Available as of cURL 7.16.2.
`CURLFTPSSL_CCC_PASSIVE` (int) | Do not initiate the shutdown, but wait for the server to do it. Do not send a reply. Available as of cURL 7.16.1.
`CURLFTPSSL_CONTROL` (int) |
`CURLFTPSSL_NONE` (int) |
`CURLFTPSSL_TRY` (int) |
`CURLFTP_CREATE_DIR` (int) | Available as of PHP 7.0.7 and cURL 7.19.3
`CURLFTP_CREATE_DIR_NONE` (int) | Available as of PHP 7.0.7 and cURL 7.19.3
`CURLFTP_CREATE_DIR_RETRY` (int) | Available as of PHP 7.0.7 and cURL 7.19.3
`CURLGSSAPI_DELEGATION_FLAG` (int) | Allow unconditional GSSAPI credential delegation. Available as of cURL 7.22.0.
`CURLGSSAPI_DELEGATION_POLICY_FLAG` (int) | Delegate only if the `OK-AS-DELEGATE` flag is set in the service ticket if this feature is supported by the GSS-API implementation and the definition of `GSS_C_DELEG_POLICY_FLAG` was available at compile-time. Available as of cURL 7.22.0.
`CURLHEADER_SEPARATE` (int) | Available as of PHP 7.0.7 and cURL 7.37.0.
`CURLHEADER_UNIFIED` (int) | Available as of PHP 7.0.7 and cURL 7.37.0.
`CURLHSTS_ENABLE` (int) | Available as of PHP 8.2.0 and cURL 7.74.0
`CURLHSTS_READONLYFILE` (int) | Available as of PHP 8.2.0 and cURL 7.74.0
`CURLKHMATCH_LAST` (int) | Available as of PHP 8.3.0 and cURL 7.19.6
`CURLKHMATCH_MISMATCH` (int) | Available as of PHP 8.3.0 and cURL 7.19.6
`CURLKHMATCH_MISSING` (int) | Available as of PHP 8.3.0 and cURL 7.19.6
`CURLKHMATCH_OK` (int) | Available as of PHP 8.3.0 and cURL 7.19.6
`CURLMIMEOPT_FORMESCAPE` (int) | Available as of PHP 8.3.0 and cURL 7.81.0
`CURLMSG_DONE` (int) |
`CURLPIPE_HTTP1` (int) | Available as of cURL 7.43.0.
`CURLPIPE_MULTIPLEX` (int) | Available as of cURL 7.43.0.
`CURLPIPE_NOTHING` (int) | Available as of cURL 7.43.0.
`CURLPROXY_HTTP` (int) | Available as of cURL 7.10.
`CURLPROXY_HTTPS` (int) | Available as of PHP 7.3.0 and cURL 7.52.0
`CURLPROXY_HTTP_1_0` (int) | Available as of PHP 7.0.7 and cURL 7.19.3
`CURLPROXY_SOCKS4` (int) | Available as of cURL 7.10.
`CURLPROXY_SOCKS4A` (int) | Available as of cURL 7.18.0.
`CURLPROXY_SOCKS5` (int) | Available as of cURL 7.10.
`CURLPROXY_SOCKS5_HOSTNAME` (int) | Available as of cURL 7.18.0.
`CURLPX_BAD_ADDRESS_TYPE` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_BAD_VERSION` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_CLOSED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_GSSAPI` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_GSSAPI_PERMSG` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_GSSAPI_PROTECTION` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_IDENTD` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_IDENTD_DIFFER` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_LONG_HOSTNAME` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_LONG_PASSWD` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_LONG_USER` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_NO_AUTH` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_OK` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_RECV_ADDRESS` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_RECV_AUTH` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_RECV_CONNECT` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_RECV_REQACK` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_ADDRESS_TYPE_NOT_SUPPORTED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_COMMAND_NOT_SUPPORTED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_CONNECTION_REFUSED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_GENERAL_SERVER_FAILURE` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_HOST_UNREACHABLE` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_NETWORK_UNREACHABLE` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_NOT_ALLOWED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_TTL_EXPIRED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REPLY_UNASSIGNED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_REQUEST_FAILED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_RESOLVE_HOST` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_SEND_AUTH` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_SEND_CONNECT` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_SEND_REQUEST` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_UNKNOWN_FAIL` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_UNKNOWN_MODE` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLPX_USER_REJECTED` (int) | Available as of PHP 8.2.0 and cURL 7.73.0
`CURLSSH_AUTH_AGENT` (int) | Available as of PHP 7.0.7 and cURL 7.28.0
`CURLSSH_AUTH_ANY` (int) |
`CURLSSH_AUTH_DEFAULT` (int) |
`CURLSSH_AUTH_GSSAPI` (int) | Available as of PHP 7.3.0 and cURL 7.58.0
`CURLSSH_AUTH_HOST` (int) |
`CURLSSH_AUTH_KEYBOARD` (int) |
`CURLSSH_AUTH_NONE` (int) |
`CURLSSH_AUTH_PASSWORD` (int) |
`CURLSSH_AUTH_PUBLICKEY` (int) |
`CURLSSLOPT_ALLOW_BEAST` (int) | Available as of cURL 7.25.0
`CURLSSLOPT_AUTO_CLIENT_CERT` (int) | Available as of PHP 8.2.0 and cURL 7.77.0
`CURLSSLOPT_NATIVE_CA` (int) | Available as of PHP 8.2.0 and cURL 7.71.0
`CURLSSLOPT_NO_PARTIALCHAIN` (int) | Available as of PHP 8.2.0 and cURL 7.68.0
`CURLSSLOPT_NO_REVOKE` (int) | Available as of PHP 7.0.7 and cURL 7.44.0
`CURLSSLOPT_REVOKE_BEST_EFFORT` (int) | Available as of PHP 8.2.0 and cURL 7.70.0
`CURLUSESSL_ALL` (int) | Require SSL for all communication or fail with `CURLE_USE_SSL_FAILED`. Available as of cURL 7.17.0.
`CURLUSESSL_CONTROL` (int) | Require SSL for the control connection or fail with `CURLE_USE_SSL_FAILED`. Available as of cURL 7.17.0.
`CURLUSESSL_NONE` (int) | Do not attempt to use SSL. Available as of cURL 7.17.0.
`CURLUSESSL_TRY` (int) | Try using SSL, proceed as normal otherwise. Note that server may close the connection if the negotiation does not succeed. Available as of cURL 7.17.0.
`CURLVERSION_NOW` (int) |
`CURLWS_RAW_MODE` (int) | Available as of PHP 8.3.0 and cURL 7.86.0
`CURL_FNMATCHFUNC_FAIL` (int) | Returned by the wildcard match callback function if an error occurred. Available as of cURL 7.21.0.
`CURL_FNMATCHFUNC_MATCH` (int) | Returned by the wildcard match callback function if pattern matches the string. Available as of cURL 7.21.0.
`CURL_FNMATCHFUNC_NOMATCH` (int) | Returned by the wildcard match callback function if pattern does not match the string. Available as of cURL 7.21.0.
`CURL_HTTP_VERSION_1_0` (int) |
`CURL_HTTP_VERSION_1_1` (int) |
`CURL_HTTP_VERSION_2` (int) | Available as of PHP 7.0.7 and cURL 7.43.0
`CURL_HTTP_VERSION_2TLS` (int) | Available as of PHP 7.0.7 and cURL 7.47.0
`CURL_HTTP_VERSION_2_0` (int) | Available as of cURL 7.33.0
`CURL_HTTP_VERSION_2_PRIOR_KNOWLEDGE` (int) | Available as of PHP 7.0.7 and cURL 7.49.0
`CURL_HTTP_VERSION_3` (int) | Available as of PHP 8.4.0 and cURL 7.66.0.
`CURL_HTTP_VERSION_3ONLY` (int) | Available as of PHP 8.4.0 and cURL 7.88.0.
`CURL_HTTP_VERSION_NONE` (int) |
`CURL_IPRESOLVE_V4` (int) | Use only IPv4 addresses when establishing a connection or choosing one from the connection pool. Available as of cURL 7.10.8.
`CURL_IPRESOLVE_V6` (int) | Use only IPv6 addresses when establishing a connection or choosing one from the connection pool. Available as of cURL 7.10.8.
`CURL_IPRESOLVE_WHATEVER` (int) | Use addresses of all IP versions allowed by the system. Available as of cURL 7.10.8.
`CURL_MAX_READ_SIZE` (int) | Available as of PHP 7.3.0 and cURL 7.53.0
`CURL_NETRC_IGNORED` (int) |
`CURL_NETRC_OPTIONAL` (int) |
`CURL_NETRC_REQUIRED` (int) |
`CURL_PUSH_DENY` (int) | Available as of PHP 7.1.0 and cURL 7.44.0
`CURL_PUSH_OK` (int) | Available as of PHP 7.1.0 and cURL 7.44.0
`CURL_READFUNC_PAUSE` (int) | Available as of cURL 7.18.0.
`CURL_REDIR_POST_301` (int) | Available as of PHP 7.0.7 and cURL 7.18.2
`CURL_REDIR_POST_302` (int) | Available as of PHP 7.0.7 and cURL 7.18.2
`CURL_REDIR_POST_303` (int) | Available as of PHP 7.0.7 and cURL 7.25.1
`CURL_REDIR_POST_ALL` (int) | Available as of PHP 7.0.7 and cURL 7.18.2
`CURL_RTSPREQ_ANNOUNCE` (int) | When sent by a client, this method changes the description of the session. `ANNOUNCE` acts like an HTTP PUT or POST just like `CURL_RTSPREQ_SET_PARAMETER`. Available as of cURL 7.20.0.
`CURL_RTSPREQ_DESCRIBE` (int) | Used to get the low level description of a stream. The application should note what formats it understands in the `Accept:` header. Unless set manually, libcurl automatically adds in `Accept: application/sdp`. Time-condition headers are added to DESCRIBE requests if the `CURLOPT_TIMECONDITION` option is used. Available as of cURL 7.20.0.
`CURL_RTSPREQ_GET_PARAMETER` (int) | Retrieve a parameter from the server. By default, libcurl adds a `Content-Type: text/parameters` header on all non-empty requests unless a custom one is set. `GET_PARAMETER` acts just like an HTTP PUT or POST. Applications wishing to send a heartbeat message should use an empty `GET_PARAMETER` request. Available as of cURL 7.20.0.
`CURL_RTSPREQ_OPTIONS` (int) | Used to retrieve the available methods of the server. Available as of cURL 7.20.0.
`CURL_RTSPREQ_PAUSE` (int) | Send a `PAUSE` command to the server. Use the `CURLOPT_RANGE` option with a single value to indicate when the stream should be halted (e.g. npt=25). Available as of cURL 7.20.0.
`CURL_RTSPREQ_PLAY` (int) | Send a `PLAY` command to the server. Use the `CURLOPT_RANGE` option to modify the playback time (e.g. npt=10-15). Available as of cURL 7.20.0.
`CURL_RTSPREQ_RECEIVE` (int) | Set the RTSP request type to this value to receive interleaved RTP data. Available as of cURL 7.20.0.
`CURL_RTSPREQ_RECORD` (int) | Used to tell the server to record a session. Use the `CURLOPT_RANGE` option to modify the record time. Available as of cURL 7.20.0.
`CURL_RTSPREQ_SETUP` (int) | Used to initialize the transport layer for the session. Available as of cURL 7.20.0.
`CURL_RTSPREQ_SET_PARAMETER` (int) | Set a parameter on the server. Available as of cURL 7.20.0.
`CURL_RTSPREQ_TEARDOWN` (int) | Terminates an RTSP session. Simply closing a connection does not terminate the RTSP session since it is valid to control an RTSP session over different connections. Available as of cURL 7.20.0.
`CURL_SSLVERSION_DEFAULT` (int) |
`CURL_SSLVERSION_MAX_DEFAULT` (int) | Available as of PHP 7.3.0 and cURL 7.54.0
`CURL_SSLVERSION_MAX_NONE` (int) | Available as of PHP 7.3.0 and cURL 7.54.0
`CURL_SSLVERSION_MAX_TLSv1_0` (int) | Available as of PHP 7.3.0 and cURL 7.54.0
`CURL_SSLVERSION_MAX_TLSv1_1` (int) | Available as of PHP 7.3.0 and cURL 7.54.0
`CURL_SSLVERSION_MAX_TLSv1_2` (int) | Available as of PHP 7.3.0 and cURL 7.54.0
`CURL_SSLVERSION_MAX_TLSv1_3` (int) | Available as of PHP 7.3.0 and cURL 7.54.0
`CURL_SSLVERSION_SSLv2` (int) |
`CURL_SSLVERSION_SSLv3` (int) |
`CURL_SSLVERSION_TLSv1` (int) |
`CURL_SSLVERSION_TLSv1_0` (int) |
`CURL_SSLVERSION_TLSv1_1` (int) |
`CURL_SSLVERSION_TLSv1_2` (int) |
`CURL_SSLVERSION_TLSv1_3` (int) | Available as of PHP 7.3.0 and cURL 7.52.0
`CURL_TIMECOND_IFMODSINCE` (int) |
`CURL_TIMECOND_IFUNMODSINCE` (int) |
`CURL_TIMECOND_LASTMOD` (int) |
`CURL_TIMECOND_NONE` (int) |
`CURL_TLSAUTH_SRP` (int) | Available as of cURL 7.21.4.
`CURL_VERSION_ALTSVC` (int) | Available as of PHP 7.3.6 and cURL 7.64.1
`CURL_VERSION_ASYNCHDNS` (int) | Asynchronous DNS resolves. Available as of PHP 7.3.0 and cURL 7.10.7
`CURL_VERSION_BROTLI` (int) | Available as of PHP 7.3.0 and cURL 7.57.0
`CURL_VERSION_CONV` (int) | Character conversions supported. Available as of PHP 7.3.0 and cURL 7.15.4
`CURL_VERSION_CURLDEBUG` (int) | Debug memory tracking supported. Available as of PHP 7.3.6 and cURL 7.19.6
`CURL_VERSION_DEBUG` (int) | Built with debug capabilities. Available as of PHP 7.3.0 and cURL 7.10.6
`CURL_VERSION_GSASL` (int) | Available as of PHP 8.2.0 and cURL 7.76.0
`CURL_VERSION_GSSAPI` (int) | Built against a GSS-API library. Available as of PHP 7.3.0 and cURL 7.38.0
`CURL_VERSION_GSSNEGOTIATE` (int) | Negotiate auth is supported. Available as of PHP 7.3.0 and cURL 7.10.6 (deprecated as of cURL 7.38.0)
`CURL_VERSION_HSTS` (int) | Available as of PHP 8.2.0 and cURL 7.74.0
`CURL_VERSION_HTTP2` (int) | HTTP2 support built-in. Available as of cURL 7.33.0
`CURL_VERSION_HTTP3` (int) | Available as of PHP 8.2.0 and cURL 7.66.0
`CURL_VERSION_HTTPS_PROXY` (int) | Available as of PHP 7.3.0 and cURL 7.52.0
`CURL_VERSION_IDN` (int) | Internationalized Domain Names are supported. Available as of PHP 7.3.0 and cURL 7.12.0
`CURL_VERSION_IPV6` (int) | IPv6-enabled.
`CURL_VERSION_KERBEROS4` (int) | Kerberos V4 auth is supported.
`CURL_VERSION_KERBEROS5` (int) | Kerberos V5 auth is supported. Available as of PHP 7.0.7 and cURL 7.40.0
`CURL_VERSION_LARGEFILE` (int) | Supports files larger than 2GB. Available as of cURL 7.33.0
`CURL_VERSION_LIBZ` (int) | libz features are present.
`CURL_VERSION_MULTI_SSL` (int) | Available as of PHP 7.3.0 and cURL 7.56.0
`CURL_VERSION_NTLM` (int) | NTLM auth is supported. Available as of PHP 7.3.0 and cURL 7.10.6
`CURL_VERSION_NTLM_WB` (int) | NTLM delegation to winbind helper is supported. Available as of PHP 7.3.0 and cURL 7.22.0
`CURL_VERSION_PSL` (int) | Mozilla's Public Suffix List, used for cookie domain verification. Available as of PHP 7.3.6 and cURL 7.47.0
`CURL_VERSION_SPNEGO` (int) | SPNEGO auth is supported. Available as of PHP 7.3.0 and cURL 7.10.8
`CURL_VERSION_SSL` (int) | SSL options are present.
`CURL_VERSION_SSPI` (int) | Built against Windows SSPI. Available as of PHP 7.3.0 and cURL 7.13.2
`CURL_VERSION_TLSAUTH_SRP` (int) | TLS-SRP auth is supported. Available as of PHP 7.3.0 and cURL 7.21.4
`CURL_VERSION_UNICODE` (int) | Available as of PHP 8.2.0 and cURL 7.72.0
`CURL_VERSION_UNIX_SOCKETS` (int) | Unix domain sockets support. Available as of PHP 7.0.7 and cURL 7.40.0
`CURL_VERSION_ZSTD` (int) | Available as of PHP 8.2.0 and cURL 7.72.0
`CURL_WRITEFUNC_PAUSE` (int) | Available as of cURL 7.18.0.
`CURL_PREREQFUNC_OK` (int) | Available as of PHP 8.4.0 and cURL 7.80.0.
`CURL_PREREQFUNC_ABORT` (int) | Available as of PHP 8.4.0 and cURL 7.80.0.

Constants | Description
--- | ---
curl_setopt()
`CURLOPT_ABSTRACT_UNIX_SOCKET` (int) | Enables the use of an abstract Unix domain socket instead of establishing a TCP connection to a host and sets the path to the given string. This option shares the same semantics as `CURLOPT_UNIX_SOCKET_PATH`. These two options share the same storage and therefore only one of them can be set per handle. Available as of PHP 7.3.0 and cURL 7.53.0.
`CURLOPT_ACCEPT_ENCODING` (int) | Sets a string with the contents of the `Accept-Encoding:` header sent in an HTTP request. Set to `null` to disable sending the `Accept-Encoding:` header. Defaults to `null`. Available as of cURL 7.21.6.
`CURLOPT_ACCEPTTIMEOUT_MS` (int) | The maximum number of milliseconds to wait for a server to connect back to cURL when an active FTP connection is used. This option accepts any value that can be cast to a valid int. Defaults to `60000` milliseconds. Available as of cURL 7.24.0.
`CURLOPT_ADDRESS_SCOPE` (int) | The scope id value to use when connecting to IPv6 addresses. This option accepts any value that can be cast to a valid int. Defaults to `0`. Available as of cURL 7.19.0.
`CURLOPT_ALTSVC` (int) | Pass a string with the filename for cURL to use as the Alt-Svc cache file to read existing cache contents from and possibly also write it back to a after a transfer, unless `CURLALTSVC_READONLYFILE` is set via `CURLOPT_ALTSVC_CTRL`. Available as of PHP 8.2.0 and cURL 7.64.1.
`CURLOPT_ALTSVC_CTRL` (int) | Populate the bitmask with the correct set of features to instruct cURL how to handle Alt-Svc for the transfers using this handle. cURL only accepts Alt-Svc headers over HTTPS. It will also only complete a request to an alternative origin if that origin is properly hosted over HTTPS. Setting any bit will enable the alt-svc engine. Set to any of the `CURLALTSVC_*` constants. Defaults to Alt-Svc handling being disabled. Available as of PHP 8.2.0 and cURL 7.64.1.
`CURLOPT_APPEND` (int) | Setting this option to `1` will cause FTP uploads to append to the remote file instead of overwriting it. Defaults to `0`. Available as of cURL 7.17.0.
`CURLOPT_AUTOREFERER` (int) | `true` to automatically set the `Referer:` field in requests where it follows a `Location:` redirect. Defaults to `0`. Available as of cURL 7.1.0.
`CURLOPT_AWS_SIGV4` (int) | Provides AWS V4 signature authentication on HTTP(S) header as a string. This option overrides any other authentication types that have been set in `CURLOPT_HTTPAUTH`. This method cannot be combined with other authentication types. Available as of PHP 8.2.0 and cURL 7.75.0.
`CURLOPT_BINARYTRANSFER` (int) | This constant is no longer used as of PHP 5.5.0. Deprecated as of PHP 8.4.0.
`CURLOPT_BUFFERSIZE` (int) | The size of the buffer to use for each read. There is no guarantee this request will be fulfilled, however. This option accepts any value that can be cast to a valid int. Defaults to `CURL_MAX_WRITE_SIZE` (currently, 16kB). Available as of cURL 7.10.
`CURLOPT_CAINFO` (int) | A string with the name of a file holding one or more certificates to verify the peer with. This only makes sense when used in combination with `CURLOPT_SSL_VERIFYPEER`. Might require an absolute path. Available as of cURL 7.4.2.
`CURLOPT_CAINFO_BLOB` (int) | A string with the name of a PEM file holding one or more certificates to verify the peer with. This option overrides `CURLOPT_CAINFO`. Available as of PHP 8.2.0 and cURL 7.77.0.
`CURLOPT_CAPATH` (int) | A string with a directory that holds multiple CA certificates. Use this option alongside `CURLOPT_SSL_VERIFYPEER`. Available as of cURL 7.9.8.
`CURLOPT_CA_CACHE_TIMEOUT` (int) | Sets the maximum time in seconds any in memory cached CA certificate store may be kept and reused for new connections. This option accepts any value that can be cast to a valid int. Defaults to `86400` (24 hours). Available as of PHP 8.3.0 and cURL 7.87.0
`CURLOPT_CERTINFO` (int) | `true` to output SSL certification information to `STDERR` on secure transfers. Requires `CURLOPT_VERBOSE` to be on to have an effect. Defaults to `false`. Available as of cURL 7.19.1.
`CURLOPT_CONNECTTIMEOUT` (int) | The number of seconds to wait while trying to connect. Use `0` to wait indefinitely. This option accepts any value that can be cast to a valid int. Defaults to `300`. Available as of cURL 7.7.0.
`CURLOPT_CONNECTTIMEOUT_MS` (int) | The number of milliseconds to wait while trying to connect. Use `0` to wait indefinitely. If cURL is built to use the standard system name resolver, that portion of the connect will still use full-second resolution for timeouts with a minimum timeout allowed of one second. This option accepts any value that can be cast to a valid int. Defaults to `300000`. Available as of cURL 7.16.2.
`CURLOPT_CONNECT_ONLY` (int) | `true` tells the library to perform all the required proxy authentication and connection setup, but no data transfer. This option is implemented for HTTP, SMTP and POP3. Defaults to `false`. Available as of cURL 7.15.2.
`CURLOPT_CONNECT_TO` (int) | Connect to a specific host and port instead of the URL's host and port. Accepts an array of strings with the format `HOST:PORT:CONNECT-TO-HOST:CONNECT-TO-PORT`. Available as of PHP 7.0.7 and cURL 7.49.0.
`CURLOPT_COOKIE` (int) | A string with the contents of the `Cookie:` header to be used in the HTTP request. Note that multiple cookies are separated with a semicolon followed by a space (e.g., `fruit=apple; colour=red`). Available as of cURL 7.1.0.
`CURLOPT_COOKIEFILE` (int) | A string with the name of the file containing the cookie data. The cookie file can be in Netscape format, or just plain HTTP-style headers dumped into a file. If the name is an empty string, no cookies are loaded, but cookie handling is still enabled. Available as of cURL 7.1.0.
`CURLOPT_COOKIEJAR` (int) | A string with the name of a file to save all internal cookies to when the handle's destructor is called. Available as of cURL 7.9.0. Warning As of PHP 8.0.0, curl_close() is a no-op and does not destroy the handle. If cookies need to be written prior to the handle being automatically destroyed, run `curl_setopt($ch, CURLOPT_COOKIELIST, "FLUSH");`.
`CURLOPT_COOKIELIST` (int) | A cookie string (i.e. a single line in Netscape/Mozilla format, or a regular HTTP-style Set-Cookie header) adds that single cookie to the internal cookie store. `ALL` erases all cookies held in memory , `SESS` erases all session cookies held in memory , `FLUSH` writes all known cookies to the file specified by `CURLOPT_COOKIEJAR` , `RELOAD` loads all cookies from the files specified by `CURLOPT_COOKIEFILE` . Available as of cURL 7.14.1.
`CURLOPT_COOKIESESSION` (int) | `true` to mark this as a new cookie "session". It will force cURL to ignore all cookies it is about to load that are "session cookies" from the previous session. By default, cURL always stores and loads all cookies, independent if they are session cookies or not. Session cookies are cookies without expiry date and they are meant to be alive and existing for this "session" only. Available as of cURL 7.9.7.
`CURLOPT_CRLF` (int) | `true` to convert Unix newlines to CRLF newlines on transfers. Available as of cURL 7.1.0.
`CURLOPT_CRLFILE` (int) | Pass a string naming a file with the concatenation of CRL (Certificate Revocation List) (in PEM format) to use in the certificate validation that occurs during the SSL exchange. When cURL is built to use GnuTLS, there is no way to influence the use of CRL passed to help in the verification process. When cURL is built with OpenSSL support, `X509_V_FLAG_CRL_CHECK` and `X509_V_FLAG_CRL_CHECK_ALL` are both set, requiring CRL check against all the elements of the certificate chain if a CRL file is passed. Also note that `CURLOPT_CRLFILE` implies `CURLSSLOPT_NO_PARTIALCHAIN` as of cURL 7.71.0 due to an OpenSSL bug. Available as of cURL 7.19.0.
`CURLOPT_CUSTOMREQUEST` (int) | A custom request method to use instead of `GET` or `HEAD` when doing a HTTP request. This is useful for doing `DELETE` or other, more obscure HTTP requests. Valid values are things like `GET`, `POST`, `CONNECT` and so on; i.e. Do not enter a whole HTTP request line here. For instance, entering `GET /index.html HTTP/1.0\r\n\r\n` would be incorrect. This option accepts a string or `null`. Available as of cURL 7.1.0. Note: Don't do this without making sure the server supports the custom request method first.
`CURLOPT_DEFAULT_PROTOCOL` (int) | A string with the default protocol to use if the URL is missing a scheme name. Available as of PHP 7.0.7 and cURL 7.45.0.
`CURLOPT_DIRLISTONLY` (int) | Setting this option to `1` will have different effects based on the protocol it is used with. FTP and SFTP based URLs will list only the names of files in a directory. POP3 will list the email message or messages on the POP3 server. For FILE, this option has no effect as directories are always listed in this mode. Using this option with `CURLOPT_WILDCARDMATCH` will prevent the latter from having any effect. Defaults to `0`. Available as of cURL 7.17.0.
`CURLOPT_DISALLOW_USERNAME_IN_URL` (int) | `true` to not allow URLs that include a username. Usernames are allowed by default. Available as of PHP 7.3.0 and cURL 7.61.0.
`CURLOPT_DNS_CACHE_TIMEOUT` (int) | The number of seconds to keep DNS entries in memory. This option is set to `120` (2 minutes) by default. This option accepts any value that can be cast to a valid int. Available as of cURL 7.9.3.
`CURLOPT_DNS_INTERFACE` (int) | Set the name of the network interface that the DNS resolver should bind to. This must be an interface name (not an address). This option accepts a string or `null`. Available as of PHP 7.0.7 and cURL 7.33.0
`CURLOPT_DNS_LOCAL_IP4` (int) | Set the local IPv4 address that the resolver should bind to. The argument should contain a single numerical IPv4 address. This option accepts a string or `null`. Available as of PHP 7.0.7 and cURL 7.33.0.
`CURLOPT_DNS_LOCAL_IP6` (int) | Set the local IPv6 address that the resolver should bind to. The argument should contain a single numerical IPv6 address. This option accepts a string or `null`. Available as of PHP 7.0.7 and cURL 7.33.0.
`CURLOPT_DNS_SERVERS` (int) | Pass a string with a comma-separated list of DNS servers to be used instead of the system default (e.g.: `192.168.1.100,192.168.1.101:8080`). Available as of cURL 7.24.0.
`CURLOPT_DNS_SHUFFLE_ADDRESSES` (int) | `true` to shuffle the order of all returned addresses so that they will be used in a random order, when a name is resolved and more than one IP address is returned. This may cause IPv4 to be used before IPv6 or vice versa. Available as of PHP 7.3.0 and cURL 7.60.0.
`CURLOPT_DNS_USE_GLOBAL_CACHE` (int) | `true` to use a global DNS cache. This option is not thread-safe. It is conditionally enabled by default if PHP is built for non-threaded use (CLI, FCGI, Apache2-Prefork, etc.). Available as of cURL 7.9.3 and deprecated as of cURL 7.11.1. As of PHP 8.4, this option no longer has any effect.
`CURLOPT_DOH_SSL_VERIFYHOST` (int) | Set to `2` to verify the DNS-over-HTTPS server's SSL certificate name fields against the host name. Available as of PHP 8.2.0 and cURL 7.76.0.
`CURLOPT_DOH_SSL_VERIFYPEER` (int) | Set to `1` to enable and `0` to disable verification of the authenticity of the DNS-over-HTTPS server's SSL certificate. Available as of PHP 8.2.0 and cURL 7.76.0.
`CURLOPT_DOH_SSL_VERIFYSTATUS` (int) | Set to `1` to enable and `0` to disable the verification of the status of the DNS-over-HTTPS server certificate using the "Certificate Status Request" TLS extension (OCSP stapling). Available as of PHP 8.2.0 and cURL 7.76.0.
`CURLOPT_DOH_URL` (int) | Provides the DNS-over-HTTPS URL. This option accepts a string or `null`. Available as of PHP 8.1.0 and cURL 7.62.0.
`CURLOPT_EGDSOCKET` (int) | Like `CURLOPT_RANDOM_FILE`, except a filename to an Entropy Gathering Daemon socket. Available as of cURL 7.7.0 and deprecated as of cURL 7.84.0.
`CURLOPT_ENCODING` (int) | The contents of the `Accept-Encoding:` header as a string. This enables decoding of the response. Supported encodings are: `identity`, `deflate`, `gzip`. If an empty string is set, a header containing all supported encoding types is sent. Available as of cURL 7.10 and deprecated as of cURL 7.21.6.
`CURLOPT_EXPECT_100_TIMEOUT_MS` (int) | The timeout for `Expect: 100-continue` responses in milliseconds. Defaults to `1000` milliseconds. This option accepts any value that can be cast to a valid int. Available as of PHP 7.0.7 and cURL 7.36.0.
`CURLOPT_FAILONERROR` (int) | `true` to fail verbosely if the HTTP code returned is greater than or equal to `400`. The default behavior is to return the page normally, ignoring the code. Available as of cURL 7.1.0.
`CURLOPT_FILE` (int) | Accepts a file handle resource to the file that the transfer should be written to. The default is `STDOUT` (the browser window). Available as of cURL 7.1.0 and deprecated as of cURL 7.9.7.
`CURLOPT_FILETIME` (int) | Set to `true` to attempt to retrieve the modification date of the remote document. This value can be retrieved using the `CURLINFO_FILETIME` option with curl_getinfo(). Available as of cURL 7.5.0.
`CURLOPT_FNMATCH_FUNCTION` (int) | Pass a callable that will be used for wildcard matching. The signature of the callback should be: callback(resource `$curlHandle`, string `$pattern`, string `$string`): int `curlHandle` The cURL handle. `pattern` The wildcard pattern. `string` The string to run the wildcard pattern matching on. The callback should return `CURL_FNMATCHFUNC_MATCH` if pattern matches the string, `CURL_FNMATCHFUNC_NOMATCH` if not or `CURL_FNMATCHFUNC_FAIL` if an error occurred. Available as of cURL 7.21.0.
`CURLOPT_FOLLOWLOCATION` (int) | Set to `true` to follow any `Location:` header that the server sends as part of the HTTP header. See also `CURLOPT_MAXREDIRS`. This constant is not available when open_basedir is enabled. Available as of cURL 7.1.0.
`CURLOPT_FORBID_REUSE` (int) | Set to `true` to force the connection to explicitly close when it has finished processing, and not be pooled for reuse. Available as of cURL 7.7.0.
`CURLOPT_FRESH_CONNECT` (int) | Set to `true` to force the use of a new connection instead of a cached one. Available as of cURL 7.7.0.
`CURLOPT_FTPAPPEND` (int) | Set to `true` to append to the remote file instead of overwriting it. Available as of cURL 7.1.0 and deprecated as of cURL 7.16.4.
`CURLOPT_FTPASCII` (int) | An alias of `CURLOPT_TRANSFERTEXT`. Use that instead. Available as of cURL 7.1, deprecated as of cURL 7.11.1 and last available in cURL 7.15.5. Removed as of PHP 7.3.0.
`CURLOPT_FTPLISTONLY` (int) | Set to `true` to only list the names of an FTP directory. Available as of cURL 7.1.0 and deprecated as of cURL 7.16.4.
`CURLOPT_FTPPORT` (int) | A string which will be used to get the IP address to use for the FTP `PORT` instruction. The `PORT` instruction tells the remote server to connect to our specified IP address. The string may be a plain IP address, a hostname, a network interface name (under Unix), or just a plain `-` to use the system's default IP address. This option accepts a string or `null`. Available as of cURL 7.1.0.
`CURLOPT_FTPSSLAUTH` (int) | Set the FTP over SSL authentication method (if activated) to any of the `CURLFTPAUTH_*` constants. Defaults to `CURLFTPAUTH_DEFAULT`. Available as of cURL 7.12.2.
`CURLOPT_FTP_ACCOUNT` (int) | Pass a string that will be sent as account information over FTP (using the `ACCT` command) after username and password has been provided to the server. Set to `null` to disable sending the account information. Defaults to `null`. Available as of cURL 7.13.0.
`CURLOPT_FTP_ALTERNATIVE_TO_USER` (int) | Pass a string that will be used to try to authenticate over FTP if the `USER/PASS` negotiation fails. Available as of cURL 7.15.5.
`CURLOPT_FTP_CREATE_MISSING_DIRS` (int) | Set to `true` to create missing directories when an FTP operation encounters a path that currently doesn't exist. Available as of cURL 7.10.7.
`CURLOPT_FTP_FILEMETHOD` (int) | Tell cURL which method to use to reach a file on a FTP(S) server. Possible values are any of the `CURLFTPMETHOD_*` constants. Defaults to `CURLFTPMETHOD_MULTICWD`. Available as of cURL 7.15.1.
`CURLOPT_FTP_RESPONSE_TIMEOUT` (int) | A timeout in seconds cURL will wait for a response from an FTP server. This option overrides `CURLOPT_TIMEOUT`. This option accepts any value that can be cast to a valid int. This option name is replaced with `CURLOPT_SERVER_RESPONSE_TIMEOUT`, available as of PHP 8.4.0. Available as of cURL 7.10.8 and deprecated as of cURL 7.85.0.
`CURLOPT_FTP_SKIP_PASV_IP` (int) | If this option is set to `1` cURL will not use the IP address the server suggests in its 227-response to cURL's `PASV` command but will use the IP address it used for the connection. The port number received from the 227-response will not be ignored by cURL. Defaults to `1` as of cURL 7.74.0 and `0` prior to that. Available as of cURL 7.15.0.
`CURLOPT_FTP_SSL` (int) | Available as of cURL 7.11.0 and deprecated as of cURL 7.16.4.
`CURLOPT_FTP_SSL_CCC` (int) | This option makes cURL use CCC (Clear Command Channel) which shuts down the SSL/TLS layer after authenticating making the rest of the control channel communication unencrypted. Use one of the `CURLFTPSSL_CCC_*` constants. Defaults to `CURLFTPSSL_CCC_NONE`. Available as of cURL 7.16.1.
`CURLOPT_FTP_USE_EPRT` (int) | Set to `true` to use `EPRT` (and `LPRT`) when doing active FTP downloads. Set to `false` to disable `EPRT` and `LPRT` and use `PORT` only. Available as of cURL 7.10.5.
`CURLOPT_FTP_USE_EPSV` (int) | Set to `true` to first try an `EPSV` command for FTP transfers before reverting back to `PASV`. Set to `false` to disable `EPSV`. Available as of cURL 7.9.2.
`CURLOPT_FTP_USE_PRET` (int) | Set to `1` to send a `PRET` command before `PASV` (and `EPSV`). Has no effect when using the active FTP transfers mode. Defaults to `0`. Available as of cURL 7.20.0.
`CURLOPT_GSSAPI_DELEGATION` (int) | Set to `CURLGSSAPI_DELEGATION_FLAG` to allow unconditional GSSAPI credential delegation. Set to `CURLGSSAPI_DELEGATION_POLICY_FLAG` to delegate only if the `OK-AS-DELEGATE` flag is set in the service ticket. Defaults to `CURLGSSAPI_DELEGATION_NONE`. Available as of cURL 7.22.0.
`CURLOPT_HAPPY_EYEBALLS_TIMEOUT_MS` (int) | Head start for IPv6 for the happy eyeballs algorithm. Happy eyeballs attempts to connect to both IPv4 and IPv6 addresses for dual-stack hosts, preferring IPv6 first for timeout milliseconds. Defaults to `CURL_HET_DEFAULT`, which is currently 200 milliseconds. This option accepts any value that can be cast to a valid int. Available as of PHP 7.3.0 and cURL 7.59.0
`CURLOPT_HAPROXYPROTOCOL` (int) | `true` to send an HAProxy `PROXY` protocol v1 header at the start of the connection. The default action is not to send this header. Available as of PHP 7.3.0 and cURL 7.60.0.
`CURLOPT_HEADER` (int) | Set to `true` to include the headers in the output sent to the callback defined by `CURLOPT_WRITEFUNCTION`. Available as of cURL 7.1.0.
`CURLOPT_HEADERFUNCTION` (int) | A callable with the following signature: callback(resource `$curlHandle`, string `$headerData`): int `curlHandle` The cURL handle. `headerData` The header data which must be written by the callback. The callback should return the number of bytes written. Available as of cURL 7.7.2.
`CURLOPT_HEADEROPT` (int) | Send HTTP headers to both proxy and host or separately. Possible values are any of the `CURLHEADER_*` constants. Defaults to `CURLHEADER_SEPARATE` as of cURL 7.42.1, and `CURLHEADER_UNIFIED` prior to that. Available as of PHP 7.0.7 and cURL 7.37.0.
`CURLOPT_HSTS` (int) | string with HSTS (HTTP Strict Transport Security) cache file name or `null` to allow HSTS without reading from or writing to any file and clear the list of files to read HSTS data from. Available as of PHP 8.2.0 and cURL 7.74.0.
`CURLOPT_HSTS_CTRL` (int) | Accepts a bitmask of HSTS (HTTP Strict Transport Security) features defined by the `CURLHSTS_*` constants. Available as of PHP 8.2.0 and cURL 7.74.0.
`CURLOPT_HTTP09_ALLOWED` (int) | Whether to allow HTTP/0.9 responses. Defaults to `false` as of cURL 7.66.0; formerly it defaulted to `true`. Available as of PHP 7.3.15 and 7.4.3, respectively, and cURL 7.64.0.
`CURLOPT_HTTP200ALIASES` (int) | An array of HTTP `200` responses that will be treated as valid responses and not as errors. Available as of cURL 7.10.3.
`CURLOPT_HTTPAUTH` (int) | A bitmask of HTTP authentication method(s) to use. The options are: `CURLAUTH_BASIC`, `CURLAUTH_DIGEST`, `CURLAUTH_GSSNEGOTIATE`, `CURLAUTH_NTLM`, `CURLAUTH_AWS_SIGV4`, `CURLAUTH_ANY`, `CURLAUTH_ANYSAFE`. If more than one method is used, cURL will poll the server to see what methods it supports and pick the best one. `CURLAUTH_ANY` sets all bits. cURL will automatically select the one it finds most secure. `CURLAUTH_ANYSAFE` sets all bits except `CURLAUTH_BASIC`. cURL will automatically select the one it finds most secure. Available as of cURL 7.10.6.
`CURLOPT_HTTPGET` (int) | Set to `true` to reset the HTTP request method to `GET`. Since `GET` is the default, this is only necessary if the request method has been changed. Available as of cURL 7.8.1.
`CURLOPT_HTTPHEADER` (int) | An array of HTTP header fields to set, in the format `array('Content-type: text/plain', 'Content-length: 100')` Available as of cURL 7.1.0.
`CURLOPT_HTTPPROXYTUNNEL` (int) | `true` to tunnel through a given HTTP proxy. Available as of cURL 7.3.0.
`CURLOPT_HTTP_CONTENT_DECODING` (int) | `false` to get the raw HTTP response body. Available as of cURL 7.16.2.
`CURLOPT_HTTP_TRANSFER_DECODING` (int) | If set to `0`, transfer decoding is disabled. If set to `1`, transfer decoding is enabled. cURL does chunked transfer decoding by default unless this option is set to `0`. Defaults to `1`. Available as of cURL 7.16.2.
`CURLOPT_HTTP_VERSION` (int) | Set to one of the `CURL_HTTP_VERSION_*` constants for cURL to use the specified HTTP version. Available as of cURL 7.9.1.
`CURLOPT_IGNORE_CONTENT_LENGTH` (int) | If set to `1`, ignore the `Content-Length` header in the HTTP response and ignore asking for or relying on it for FTP transfers. Defaults to `0`. Available as of cURL 7.14.1.
`CURLOPT_INFILE` (int) | Accepts a file handle resource to the file that the transfer should be read from when uploading. Available as of cURL 7.1.0 and deprecated as of cURL 7.9.7. Use `CURLOPT_READDATA` instead.
`CURLOPT_INFILESIZE` (int) | The expected size, in bytes, of the file when uploading a file to a remote site. Note that using this option will not stop cURL from sending more data, as exactly what is sent depends on `CURLOPT_READFUNCTION`. This option accepts any value that can be cast to a valid int. Available as of cURL 7.1.0.
`CURLOPT_INTERFACE` (int) | Set to a string with the name of the outgoing network interface to use. This can be an interface name, an IP address or a host name. Available as of cURL 7.1.0.
`CURLOPT_IPRESOLVE` (int) | Allows an application to select what kind of IP addresses to use when resolving host names. This is only interesting when using host names that resolve addresses using more than one version of IP. Set to one of the `CURL_IPRESOLVE_*` constants. Defaults to `CURL_IPRESOLVE_WHATEVER`. Available as of cURL 7.10.8.
`CURLOPT_ISSUERCERT` (int) | If set to a string naming a file holding a CA certificate in PEM format, an additional check against the peer certificate is performed to verify the issuer is indeed the one associated with the certificate provided by the option. For the result of the check to be considered a failure, this option should be used in combination with the `CURLOPT_SSL_VERIFYPEER` option. Available as of cURL 7.19.0.
`CURLOPT_ISSUERCERT_BLOB` (int) | Pass a string with binary data of a CA SSL certificate in PEM format. If set, an additional check against the peer certificate is performed to verify the issuer is the one associated with the certificate provided by the option. Available as of PHP 8.1.0 and cURL 7.71.0.
`CURLOPT_KEEP_SENDING_ON_ERROR` (int) | Set to `true` to keep sending the request body if the HTTP code returned is equal to or larger than `300`. The default action would be to stop sending and close the stream or connection. Suitable for manual NTLM authentication. Most applications do not need this option. Available as of PHP 7.3.0 and cURL 7.51.0.
`CURLOPT_KEYPASSWD` (int) | Set to a string with the password required to use the `CURLOPT_SSLKEY` or `CURLOPT_SSH_PRIVATE_KEYFILE` private key. Setting this option to `null` disables using a password for these options. Available as of cURL 7.17.0.
`CURLOPT_KRB4LEVEL` (int) | The KRB4 (Kerberos 4) security level. Any of the following string values (in order from least to most powerful) are valid: `clear`, `safe`, `confidential`, `private`. If the string does not match one of these, `private` is used. Setting this option to `null` will disable KRB4 security. Currently KRB4 security only works with FTP transactions. Available as of cURL 7.3.0 and deprecated as of cURL 7.17.0.
`CURLOPT_KRBLEVEL` (int) | Set the kerberos security level for FTP and also enables kerberos awareness. This should be set to one of the following strings: `clear`, `safe`, `confidential`, `private`. If the string is set but does not match one of these, `private` is used. Setting this option to `null` will disable kerberos support for FTP. Defaults to `null`. Available as of cURL 7.16.4.
`CURLOPT_LOCALPORT` (int) | Sets the local port number of the socket used for the connection. This option accepts any value that can be cast to a valid int. Defaults to `0`. Available as of cURL 7.15.2.
`CURLOPT_LOCALPORTRANGE` (int) | The number of attempts cURL makes to find a working local port number, starting with the one set with `CURLOPT_LOCALPORT`. This option accepts any value that can be cast to a valid int. Defaults to `1`. Available as of cURL 7.15.2.
`CURLOPT_LOGIN_OPTIONS` (int) | Can be used to set protocol specific login options, such as the preferred authentication mechanism via `AUTH=NTLM` or `AUTH=*`, and should be used in conjunction with the `CURLOPT_USERNAME` option. Available as of PHP 7.0.7 and cURL 7.34.0.
`CURLOPT_LOW_SPEED_LIMIT` (int) | The transfer speed, in bytes per second, that the transfer should be below during the count of `CURLOPT_LOW_SPEED_TIME` seconds before PHP considers the transfer too slow and aborts. This option accepts any value that can be cast to a valid int. Available as of cURL 7.1.0.
`CURLOPT_LOW_SPEED_TIME` (int) | The number of seconds the transfer speed should be below `CURLOPT_LOW_SPEED_LIMIT` before PHP considers the transfer too slow and aborts. This option accepts any value that can be cast to a valid int. Available as of cURL 7.1.0.
`CURLOPT_MAIL_AUTH` (int) | Set a string with the authentication address (identity) of a submitted message that is being relayed to another server. The address should not be specified within a pair of angled brackets (`<>`). If an empty string is used then a pair of brackets are sent by cURL as required by RFC 2554. Available as of cURL 7.25.0.
`CURLOPT_MAIL_FROM` (int) | Set a string with the sender's email address when sending SMTP mail. The email address should be specified with angled brackets (`<>`) around it, which if not specified are added automatically. If this parameter is not specified then an empty address is sent to the SMTP server which might cause the email to be rejected. Available as of cURL 7.20.0.
`CURLOPT_MAIL_RCPT` (int) | Set to an array of strings with the recipients to pass to the server in an SMTP mail request. Each recipient should be specified within a pair of angled brackets (`<>`). If an angled bracket is not used as the first character, cURL assumes a single email address has been provided and encloses that address within brackets. Available as of cURL 7.20.0.
`CURLOPT_MAIL_RCPT_ALLLOWFAILS` (int) | Set to `1` to allow `RCPT TO` command to fail for some recipients which makes cURL ignore errors for individual recipients and proceed with the remaining accepted recipients. If all recipients trigger failures and this flag is specified, cURL aborts the SMTP conversation and returns the error received from to the last `RCPT TO` command. Replaced by `CURLOPT_MAIL_RCPT_ALLOWFAILS` as of cURL 8.2.0. Available as of PHP 8.2.0 and cURL 7.69.0. Deprecated as of cURL 8.2.0.
`CURLOPT_MAXAGE_CONN` (int) | The maximum idle time allowed for an existing connection to be considered for reuse. Default maximum age is set to `118` seconds. This option accepts any value that can be cast to a valid int. Available as of PHP 8.2.0 and cURL 7.65.0.
`CURLOPT_MAXCONNECTS` (int) | The maximum amount of persistent connections that are allowed. When the limit is reached, the oldest one in the cache is closed to prevent increasing the number of open connections. This option accepts any value that can be cast to a valid int. Available as of cURL 7.7.0.
`CURLOPT_MAXFILESIZE` (int) | Sets the maximum accepted size (in bytes) of a file to download. If the file requested is found larger than this value, the transfer is aborted and `CURLE_FILESIZE_EXCEEDED` is returned. Passing `0` disables this option, and passing a negative size returns a `CURLE_BAD_FUNCTION_ARGUMENT`. If the file size is not known prior to the start of download, this option has no effect. For setting a size limit above `2GB`, `CURLOPT_MAXFILESIZE_LARGE` should be used. As of cURL 8.4.0, this option also stops ongoing transfers if they reach this threshold. This option accepts any value that can be cast to a valid int. Defaults to `0`. Available as of cURL 7.10.8.
`CURLOPT_MAXFILESIZE_LARGE` (int) | The maximum file size in bytes allowed to download. If the file requested is found larger than this value, the transfer will not start and `CURLE_FILESIZE_EXCEEDED` will be returned. The file size is not always known prior to download, and for such files this option has no effect even if the file transfer ends up being larger than this given limit. This option accepts any value that can be cast to a valid int. Available as of PHP 8.2.0 and cURL 7.11.0.
`CURLOPT_MAXLIFETIME_CONN` (int) | The maximum time in seconds, since the creation of the connection, that is allowed for an existing connection to have for it to be considered for reuse. If a connection is found in the cache that is older than this value, it will instead be closed once any in-progress transfers are complete. Default is `0` seconds, meaning the option is disabled and all connections are eligible for reuse. This option accepts any value that can be cast to a valid int. Available as of PHP 8.2.0 and cURL 7.80.0.
`CURLOPT_MAXREDIRS` (int) | The maximum amount of HTTP redirections to follow. Use this option alongside `CURLOPT_FOLLOWLOCATION`. Default value of `20` is set to prevent infinite redirects. Setting to `-1` allows inifinite redirects, and `0` refuses all redirects. Available as of cURL 7.5.0.
`CURLOPT_MAX_RECV_SPEED_LARGE` (int) | If a download exceeds this speed (counted in bytes per second) on cumulative average during the transfer, the transfer will pause to keep the average rate less than or equal to the parameter value. Defaults to unlimited speed. This option accepts any value that can be cast to a valid int. Available as of cURL 7.15.5.
`CURLOPT_MAX_SEND_SPEED_LARGE` (int) | If an upload exceeds this speed (counted in bytes per second) on cumulative average during the transfer, the transfer will pause to keep the average rate less than or equal to the parameter value. Defaults to unlimited speed. This option accepts any value that can be cast to a valid int. Available as of cURL 7.15.5.
`CURLOPT_MIME_OPTIONS` (int) | Set to a bitmask of `CURLMIMEOPT_*` constants. Currently there is only one available option: `CURLMIMEOPT_FORMESCAPE`. Available as of PHP 8.3.0 and cURL 7.81.0.
`CURLOPT_MUTE` (int) | Set to `true` to be completely silent with regards to the cURL functions. Use `CURLOPT_RETURNTRANSFER` instead. Available as of cURL 7.1.0, deprecated as of cURL 7.8.0 and last available in cURL 7.15.5. Removed as of PHP 7.3.0.
`CURLOPT_NETRC` (int) | Set to `true` to scan the ~/.netrc file to find a username and password for the remote site that a connection is being established with. Available as of cURL 7.1.0.
`CURLOPT_NETRC_FILE` (int) | Set a string containing the full path name to a `.netrc` file. If this option is omitted and `CURLOPT_NETRC` is set, cURL checks for a `.netrc` file in the current user's home directory. Available as of cURL 7.11.0.
`CURLOPT_NEW_DIRECTORY_PERMS` (int) | Sets the value of the permissions (int) that is set on newly created directories on the remote server. The default value is `0755`. The only protocols that can use this are `sftp://`, `scp://` and `file://`. Available as of cURL 7.16.4.
`CURLOPT_NEW_FILE_PERMS` (int) | Sets the value of the permissions (as an int) that are set on newly created files on the remote server. The default value is `0644`. The only protocols that can use this are `sftp://`, `scp://` and `file://`. Available as of cURL 7.16.4.
`CURLOPT_NOBODY` (int) | Set to `true` to exclude the body from the output. For HTTP(S), cURL makes a HEAD request. For most other protocols, cURL is not asking for the body data at all. Changing this to `false` will result in body data being included in the output. Available as of cURL 7.1.0.
`CURLOPT_NOPROGRESS` (int) | Set to `true` to disable the progress meter for cURL transfers. Note: PHP automatically sets this option to `true`, this should only be changed for debugging purposes. Available as of cURL 7.1.0.
`CURLOPT_NOPROXY` (int) | Set a string consisting of a comma separated list of hostnames that do not require a proxy to get reached. Each name in this list is matched as either a domain which contains the hostname or the hostname itself. The only wildcard available in the string is a single `*` character which matches all hosts, effectively disabling the proxy. Setting this option to an empty string enables the proxy for all hostnames. Since cURL 7.86.0, IP addresses set with this option can be provided using CIDR notation. Available as of cURL 7.19.4.
`CURLOPT_NOSIGNAL` (int) | `true` to ignore any cURL function that causes a signal to be sent to the PHP process. This is turned on by default in multi-threaded SAPIs so timeout options can still be used. Available as of cURL 7.10.
`CURLOPT_PASSWDFUNCTION` (int) | A callable with the following signature: callback(resource `$curlHandle`, string `$passwordPrompt`, int `$maximumPasswordLength`): string `curlHandle` The cURL handle. `passwordPrompt` A password prompt. `maximumPasswordLength` The maximum length of the password. The callback should return a string containing the password. Available as of cURL 7.4.2, deprecated as of cURL 7.11.1 and last available in cURL 7.15.5. Removed as of PHP 7.3.0.
`CURLOPT_PASSWORD` (int) | Set to a string with the password to use in authentication. Available as of cURL 7.19.1.
`CURLOPT_PATH_AS_IS` (int) | Set to `true` for cURL not alter URL paths before passing them on to the server. Defaults to `false`, which squashes sequences of `/../` or `/./` that may exist in the URL's path part which is supposed to be removed according to RFC 3986 section 5.2.4. Available as of PHP 7.0.7 and cURL 7.42.0.
`CURLOPT_PINNEDPUBLICKEY` (int) | Set a string with the pinned public key. The string can be the file name of the pinned public key in a PEM or DER file format. The string can also be any number of base64 encoded sha256 hashes preceded by `sha256//` and separated by `;`. Available as of PHP 7.0.7 and cURL 7.39.0.
`CURLOPT_PIPEWAIT` (int) | Set to `true` to wait for an existing connection to confirm whether it can do multiplexing and use it if it can before creating and using a new connection. Available as of PHP 7.0.7 and cURL 7.43.0.
`CURLOPT_PORT` (int) | An int with an alternative port number to connect to instead of the one specified in the URL or the default port for the used protocol. Available as of cURL 7.1.0.
`CURLOPT_POST` (int) | Set to `true` to do a HTTP `POST` request. This request uses the `application/x-www-form-urlencoded` header. Defaults to `false`. Available as of cURL 7.1.0.
`CURLOPT_POSTFIELDS` (int) | The full data to post in a HTTP `POST` operation. This parameter can either be passed as a urlencoded string like '`para1=val1&para2=val2&...`' or as an array with the field name as key and field data as value. If `value` is an array, the `Content-Type` header will be set to `multipart/form-data`. Files can be sent using CURLFile or CURLStringFile, in which case `value` must be an array. Available as of cURL 7.1.0.
`CURLOPT_POSTQUOTE` (int) | An array of FTP command strings to execute on the server after the FTP request has been performed. Available as of cURL 7.1.0.
`CURLOPT_POSTREDIR` (int) | Set to a bitmask of `CURL_REDIR_POST_301`, `CURL_REDIR_POST_302` and `CURL_REDIR_POST_303` if the HTTP `POST` method should be maintained when `CURLOPT_FOLLOWLOCATION` is set and a specific type of redirect occurs. Available as of cURL 7.19.1.
`CURLOPT_PRE_PROXY` (int) | Set a string holding the host name or dotted numerical IP address to be used as the preproxy that cURL connects to before it connects to the HTTP(S) proxy specified in the `CURLOPT_PROXY` option for the upcoming request. The preproxy can only be a SOCKS proxy and it should be prefixed with `[scheme]://` to specify which kind of socks is used. A numerical IPv6 address must be written within [brackets]. Setting the preproxy to an empty string explicitly disables the use of a preproxy. To specify port number in this string, append `:[port]` to the end of the host name. The proxy's port number may optionally be specified with the separate option `CURLOPT_PROXYPORT`. Defaults to using port 1080 for proxies if a port is not specified. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PREQUOTE` (int) | Set an array of FTP command strings to pass to the server after the transfer type is set. These commands are not performed when a directory listing is performed, only for file transfers. Available as of cURL 7.9.5.
`CURLOPT_PRIVATE` (int) | Any data that should be associated with this cURL handle. This data can subsequently be retrieved with the `CURLINFO_PRIVATE` option of curl_getinfo(). cURL does nothing with this data. When using a cURL multi handle, this private data is typically a unique key to identify a standard cURL handle. Available as of cURL 7.10.3.
`CURLOPT_PROGRESSFUNCTION` (int) | A callable with the following signature: callback( resource `$curlHandle`, int `$bytesToDownload`, int `$bytesDownloaded`, int `$bytesToUpload`, int `$bytesUploaded` ): int `curlHandle` The cURL handle. `bytesToDownload` The total number of bytes expected to be downloaded in this transfer. `bytesDownloaded` The number of bytes downloaded so far. `bytesToUpload` The total number of bytes expected to be uploaded in this transfer. `bytesUploaded` The number of bytes uploaded so far. The callback should return an int with a non-zero value to abort the transfer and set a `CURLE_ABORTED_BY_CALLBACK` error. Note: The callback is only called when the `CURLOPT_NOPROGRESS` option is set to `false`. Available as of cURL 7.1.0 and deprecated as of cURL 7.32.0. Use `CURLOPT_XFERINFOFUNCTION` instead.
`CURLOPT_PROTOCOLS` (int) | Bitmask of `CURLPROTO_*` values. If used, this bitmask limits what protocols cURL may use in the transfer. Defaults to `CURLPROTO_ALL`, ie. cURL will accept all protocols it supports. See also `CURLOPT_REDIR_PROTOCOLS`. Available as of cURL 7.19.4 and deprecated as of cURL 7.85.0.
`CURLOPT_PROTOCOLS_STR` (int) | Set to a string with a comma separated list of case insensitive protocol names (URL schemes) to allow in the transfer. Set to `ALL` to enable all protocols. By default, cURL accepts all protocols it was built with support for. Available protocols are: `DICT`, `FILE`, `FTP`, `FTPS`, `GOPHER`, `GOPHERS`, `HTTP`, `HTTPS`, `IMAP`, `IMAPS`, `LDAP`, `LDAPS`, `MQTT`, `POP3`, `POP3S`, `RTMP`, `RTMPE`, `RTMPS`, `RTMPT`, `RTMPTE`, `RTMPTS`, `RTSP`, `SCP`, `SFTP`, `SMB`, `SMBS`, `SMTP`, `SMTPS`, `TELNET`, `TFTP`, `WS`, `WSS`. Available as of PHP 8.3.0 and cURL 7.85.0.
`CURLOPT_PROXY` (int) | A string with the HTTP proxy to tunnel requests through. This should be the hostname, the dotted numerical IP address or a numerical IPv6 address written within [brackets]. Available as of cURL 7.1.0.
`CURLOPT_PROXYAUTH` (int) | A bitmask of the HTTP authentication method(s) (`CURLAUTH_*` constants) to use for the proxy connection. For proxy authentication, only `CURLAUTH_BASIC` and `CURLAUTH_NTLM` are currently supported. Defaults to `CURLAUTH_BASIC`. Available as of cURL 7.10.7.
`CURLOPT_PROXYHEADER` (int) | An array of custom HTTP header strings to pass to proxies. Available as of PHP 7.0.7 and cURL 7.37.0.
`CURLOPT_PROXYPASSWORD` (int) | Set a string with the password to be used for authentication with the proxy. Available as of cURL 7.19.1.
`CURLOPT_PROXYPORT` (int) | An int with the port number of the proxy to connect to. This port number can also be set in `CURLOPT_PROXY`. Setting this to zero makes cURL use the default proxy port number or the port number specified in the proxy URL string. Available as of cURL 7.1.0.
`CURLOPT_PROXYTYPE` (int) | Sets the type of the proxy to one of the `CURLPROXY_*` constants. Defaults to `CURLPROXY_HTTP`. Available as of cURL 7.10.
`CURLOPT_PROXYUSERNAME` (int) | Set a string with the username to be used for authentication with the proxy. Available as of cURL 7.19.1.
`CURLOPT_PROXYUSERPWD` (int) | A string with a username and password formatted as `[username]:[password]` to use for the connection to the proxy. Available as of cURL 7.1.0.
`CURLOPT_PROXY_CAINFO` (int) | The path to proxy Certificate Authority (CA) bundle. Set the path as a string naming a file holding one or more certificates to verify the HTTPS proxy with. This option is for connecting to an HTTPS proxy, not an HTTPS server. Defaults set to the system path where cURL's cacert bundle is assumed to be stored. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_CAINFO_BLOB` (int) | A string with the name of a PEM file holding one or more certificates to verify the HTTPS proxy with. This option is for connecting to an HTTPS proxy, not an HTTPS server. Defaults set to the system path where cURL's cacert bundle is assumed to be stored. Available as of PHP 8.2.0 and cURL 7.77.0.
`CURLOPT_PROXY_CAPATH` (int) | A string with the directory holding multiple CA certificates to verify the HTTPS proxy with. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_CRLFILE` (int) | Set to a string with the file name with the concatenation of CRL (Certificate Revocation List) in PEM format to use in the certificate validation that occurs during the SSL exchange. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_ISSUERCERT` (int) | Proxy issuer SSL certificate filename string. Available as of PHP 8.1.0 and cURL 7.71.0.
`CURLOPT_PROXY_ISSUERCERT_BLOB` (int) | A string with the proxy issuer SSL certificate. Available as of PHP 8.1.0 and cURL 7.71.0.
`CURLOPT_PROXY_KEYPASSWD` (int) | Set the string be used as the password required to use the `CURLOPT_PROXY_SSLKEY` private key. A passphrase is not needed to load a certificate but one is needed to load a private key. This option is for connecting to an HTTPS proxy, not an HTTPS server. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_PINNEDPUBLICKEY` (int) | Set the pinned public key for HTTPS proxy. The string can be the file name of the pinned public key which is expected to be in a `PEM` or `DER` file format. The string can also be any number of base64 encoded sha256 hashes preceded by `sha256//` and separated by `;`. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SERVICE_NAME` (int) | A string with the proxy authentication service name. Available as of PHP 7.0.7, cURL 7.43.0 (for HTTP proxies) and cURL 7.49.0 (for SOCKS5 proxies).
`CURLOPT_PROXY_SSLCERT` (int) | A string with the file name of the client certificate used to connect to the HTTPS proxy. The default format is `P12` on Secure Transport and `PEM` on other engines, and can be changed with `CURLOPT_PROXY_SSLCERTTYPE`. With NSS or Secure Transport, this can also be the nickname of the certificate used for authentication as it is named in the security database. If a file from the current directory is to be used, it must be prefixed with `./` in order to avoid confusion with a nickname. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSLCERTTYPE` (int) | A string with the format of the client certificate used when connecting to an HTTPS proxy. Supported formats are `PEM` and `DER`, except with Secure Transport. OpenSSL (versions 0.9.3 and later) and Secure Transport (on iOS 5 or later, or OS X 10.7 or later) also support `P12` for PKCS#12-encoded files. Defaults to `PEM`. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSLCERT_BLOB` (int) | A string with the SSL proxy client certificate. Available as of PHP 8.1.0 and cURL 7.71.0.
`CURLOPT_PROXY_SSLKEY` (int) | A string with the file name of the private key used for connecting to the HTTPS proxy. The default format is `PEM` and can be changed with `CURLOPT_PROXY_SSLKEYTYPE`. (iOS and Mac OS X only) This option is ignored if cURL was built against Secure Transport. Available if built with TLS enabled. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSLKEYTYPE` (int) | A string with the format of the private key. Supported formats are: `PEM`, `DER`, `ENG`. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSLKEY_BLOB` (int) | A string with the private key for connecting to the HTTPS proxy. Available as of PHP 8.1.0 and cURL 7.71.0.
`CURLOPT_PROXY_SSLVERSION` (int) | Set the preferred HTTPS proxy TLS version to one of the `CURL_SSLVERSION_*` constants. Defaults to `CURL_SSLVERSION_DEFAULT`. Warning It is better to not set this option and leave the default `CURL_SSLVERSION_DEFAULT` which will attempt to figure out the remote SSL protocol version. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSL_CIPHER_LIST` (int) | A string with a colon-separated list of ciphers to use for the connection to the HTTPS proxy. When used with OpenSSL commas and spaces are also acceptable as separators, and `!`, `-` and `+` can be used as operators. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSL_OPTIONS` (int) | Set proxy SSL behavior options, which is a bitmask of the `CURLSSLOPT_*` constants. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSL_VERIFYHOST` (int) | Set to `2` to verify in the HTTPS proxy's certificate name fields against the proxy name. When set to `0` the connection succeeds regardless of the names used in the certificate. Use that ability with caution! Set to `1` in cURL 7.28.0 and earlier as a debug option. Set to `1` in cURL 7.28.1 to 7.65.3 `CURLE_BAD_FUNCTION_ARGUMENT` is returned. As of cURL 7.66.0 `1` and `2` is treated as the same value. Defaults to `2`. In production environments the value of this option should be kept at `2`. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_SSL_VERIFYPEER` (int) | Set to `false` to stop cURL from verifying the peer's certificate. Alternate certificates to verify against can be specified with the `CURLOPT_CAINFO` option or a certificate directory can be specified with the `CURLOPT_CAPATH` option. When set to `false`, the peer certificate verification succeeds regardless. `true` by default. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_TLS13_CIPHERS` (int) | A string with a colon-separated list of ciphers to use for the connection to the TLS 1.3 connection to a proxy. This option is currently used only when cURL is built to use OpenSSL 1.1.1 or later. When using a different SSL backend the TLS 1.3 cipher suites can be set with the `CURLOPT_PROXY_SSL_CIPHER_LIST` option. Available as of PHP 7.3.0 and cURL 7.61.0.
`CURLOPT_PROXY_TLSAUTH_PASSWORD` (int) | A string with the password to use for the TLS authentication method specified with the `CURLOPT_PROXY_TLSAUTH_TYPE` option. Requires that the `CURLOPT_PROXY_TLSAUTH_USERNAME` option to also be set. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_TLSAUTH_TYPE` (int) | The method of the TLS authentication used for the HTTPS connection. Supported method is `SRP`. Note: Secure Remote Password (SRP) authentication for TLS provides mutual authentication if both sides have a shared secret. To use TLS-SRP, the `CURLOPT_PROXY_TLSAUTH_USERNAME` and `CURLOPT_PROXY_TLSAUTH_PASSWORD` options must also be set. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_TLSAUTH_USERNAME` (int) | The username to use for the HTTPS proxy TLS authentication method specified with the `CURLOPT_PROXY_TLSAUTH_TYPE` option. Requires that the `CURLOPT_PROXY_TLSAUTH_PASSWORD` option to also be set. Available as of PHP 7.3.0 and cURL 7.52.0.
`CURLOPT_PROXY_TRANSFER_MODE` (int) | Set to `1` to set the transfer mode (binary or ASCII) for FTP transfers done via an HTTP proxy, by appending `type=a` or `type=i` to the URL. Without this setting or it being set to `0`, `CURLOPT_TRANSFERTEXT` has no effect when doing FTP via a proxy. Defaults to `0`. Available as of cURL 7.18.0.
`CURLOPT_PUT` (int) | `true` to HTTP PUT a file. The file to PUT must be set with `CURLOPT_READDATA` and `CURLOPT_INFILESIZE`. Available as of cURL 7.1.0 and deprecated as of cURL 7.12.1.
`CURLOPT_QUICK_EXIT` (int) | Set to `true` for cURL to skip cleanup of resources when recovering from a timeout. This allows for a swift termination of the cURL process at the expense of a possible leak of associated resources. Available as of PHP 8.3.0 and cURL 7.87.0.
`CURLOPT_QUOTE` (int) | An array of FTP command strings to execute on the server prior to the FTP request. Available as of cURL 7.1.0.
`CURLOPT_RANDOM_FILE` (int) | A string with a filename to be used to seed the random number generator for SSL. Available as of cURL 7.7.0 and deprecated as of cURL 7.84.0.
`CURLOPT_RANGE` (int) | A string with the range(s) of data to retrieve in the format `X-Y` where X or Y are optional. HTTP transfers also support several intervals, separated with commas in the format `X-Y,N-M`. Set to `null` to disable requesting a byte range. Available as of cURL 7.1.0.
`CURLOPT_READDATA` (int) | Sets a file pointer resource that will be used by the file read function set with `CURLOPT_READFUNCTION`. Available as of cURL 7.9.7.
`CURLOPT_READFUNCTION` (int) | A callable with the following signature: callback(resource `$curlHandle`, resource `$streamResource`, int `$maxAmountOfDataToRead`): string `curlHandle` The cURL handle. `streamResource` Stream resource provided to cURL through the option `CURLOPT_READDATA`. `maxAmountOfDataToRead` The maximum amount of data to be read. The callback should return a string with a length equal or smaller than the amount of data requested, typically by reading it from the passed stream resource. It should return an empty string to signal `EOF`. Available as of cURL 7.1.0.
`CURLOPT_REDIR_PROTOCOLS` (int) | Bitmask of `CURLPROTO_*` values which limit what protocols cURL may use in a transfer that it follows to in a redirect when `CURLOPT_FOLLOWLOCATION` is enabled. This allows limiting specific transfers to only be allowed to use a subset of protocols in redirections. As of cURL 7.19.4, by default cURL will allow all protocols except for `FILE` and `SCP`. Prior to cURL 7.19.4, cURL would unconditionally follow to all supported protocols. See also `CURLOPT_PROTOCOLS` for protocol constant values. Available as of cURL 7.19.4 and deprecated as of cURL 7.85.0.
`CURLOPT_REDIR_PROTOCOLS_STR` (int) | Set to a string with a comma separated list of case insensitive protocol names (URL schemes) to allow to follow to in a redirect when `CURLOPT_FOLLOWLOCATION` is enabled. Set to `ALL` to enable all protocols. As of cURL 7.65.2 it defaults to `FTP`, `FTPS`, `HTTP` and `HTTPS`. From cURL 7.40.0 to 7.65.1, this defaults to all protocols except `FILE`, `SCP`, `SMB` and `SMBS`. Prior to cURL 7.40.0, this defaults to all protocols except `FILE` and `SCP`. Available protocols are: `DICT`, `FILE`, `FTP`, `FTPS`, `GOPHER`, `GOPHERS`, `HTTP`, `HTTPS`, `IMAP`, `IMAPS`, `LDAP`, `LDAPS`, `MQTT`, `POP3`, `POP3S`, `RTMP`, `RTMPE`, `RTMPS`, `RTMPT`, `RTMPTE`, `RTMPTS`, `RTSP`, `SCP`, `SFTP`, `SMB`, `SMBS`, `SMTP`, `SMTPS`, `TELNET`, `TFTP`, `WS`, `WSS`. Available as of PHP 8.3.0 and cURL 7.85.0.
`CURLOPT_REFERER` (int) | A string with the contents of the `Referer:` header to be used in a HTTP request. Available as of cURL 7.1.0.
`CURLOPT_REQUEST_TARGET` (int) | A string to use in the upcoming request instead of the path as extracted from the URL. Available as of PHP 7.3.0 and cURL 7.55.0.
`CURLOPT_RESOLVE` (int) | Provide an array of colon-separated strings with custom addresses for specific host and port pairs in the following format: `array( "example.com:80:127.0.0.1", "example2.com:443:127.0.0.2", )` Available as of cURL 7.21.3.
`CURLOPT_RESUME_FROM` (int) | The offset, in bytes, to resume a transfer from. This option accepts any value that can be cast to a valid int. Available as of cURL 7.1.0.
`CURLOPT_RETURNTRANSFER` (int) | `true` to return the transfer as a string of the return value of curl_exec() instead of outputting it directly.
`CURLOPT_RTSP_CLIENT_CSEQ` (int) | Set an int with the CSEQ number to issue for the next RTSP request. Useful if the application is resuming a previously broken connection. The CSEQ increments from this new number henceforth. Defaults to `0`. Available as of cURL 7.20.0.
`CURLOPT_RTSP_REQUEST` (int) | Sets the kind of RTSP request to make. Must be one of the `CURL_RTSPREQ_*` constants. Available as of cURL 7.20.0.
`CURLOPT_RTSP_SERVER_CSEQ` (int) | Set an int with the CSEQ number to expect for the next RTSP Server to Client request. This feature (listening for Server requests) is unimplemented. Defaults to `0`. Available as of cURL 7.20.0.
`CURLOPT_RTSP_SESSION_ID` (int) | Set a string with the value of the current RTSP Session ID for the handle. Once this value is set to any non-`null` value, cURL returns `CURLE_RTSP_SESSION_ERROR` if the ID received from the server does not match. If set to `null`, cURL automatically sets the ID the first time the server sets it in a response. Defaults to `null` Available as of cURL 7.20.0.
`CURLOPT_RTSP_STREAM_URI` (int) | Sets a string with the stream URI to operate on. If not set, cURL defaults to operating on generic server options by passing `*` in the place of the RTSP Stream URI. When working with RTSP, `CURLOPT_RTSP_STREAM_URI` indicates what URL to send to the server in the request header while the `CURLOPT_URL` indicates where to make the connection to. Available as of cURL 7.20.0.
`CURLOPT_RTSP_TRANSPORT` (int) | Set the `Transport:` header for this RTSP session. Available as of cURL 7.20.0.
`CURLOPT_SAFE_UPLOAD` (int) | Always `true`, what disables support for the `@` prefix for uploading files in `CURLOPT_POSTFIELDS`, which means that values starting with `@` can be safely passed as fields. CURLFile may be used for uploads instead.
`CURLOPT_SASL_AUTHZID` (int) | The authorization identity (authzid) string for the transfer. Only applicable to the PLAIN SASL authentication mechanism where it is optional. When not specified, only the authentication identity (authcid) as specified by the username will be sent to the server, along with the password. The server will derive the authzid from the authcid when not provided, which it will then use internally. Available as of PHP 8.2.0 and cURL 7.66.0.
`CURLOPT_SASL_IR` (int) | `true` to enable sending the initial response in the first packet. Available as of PHP 7.0.7 and cURL 7.31.0.
`CURLOPT_SERVICE_NAME` (int) | A string with the authentication service name. Available as of PHP 7.0.7 and cURL 7.43.0.
`CURLOPT_SHARE` (int) | A result of curl_share_init(). Makes the cURL handle to use the data from the shared handle. Available as of cURL 7.10.
`CURLOPT_SOCKS5_AUTH` (int) | The SOCKS5 authentication method(s) to use. The options are: `CURLAUTH_BASIC`, `CURLAUTH_GSSAPI`, `CURLAUTH_NONE`. When more than one method is set, cURL will poll the server to see what methods it supports and pick the best one. Defaults to `CURLAUTH_BASIC|CURLAUTH_GSSAPI`. Set the actual username and password with the `CURLOPT_PROXYUSERPWD` option. Available as of PHP 7.3.0 and cURL 7.55.0.
`CURLOPT_SOCKS5_GSSAPI_NEC` (int) | Set to `1` to enable and `0` to disable the unprotected exchange of the protection mode negotiation as part of the GSSAPI negotiation. Available as of cURL 7.19.4.
`CURLOPT_SOCKS5_GSSAPI_SERVICE` (int) | Set a string holding the name of the SOCKS5 service. Defaults to `rcmd`. Available as of cURL 7.19.4 and deprecated as of cURL 7.49.0. Use `CURLOPT_PROXY_SERVICE_NAME` instead.
`CURLOPT_SSH_AUTH_TYPES` (int) | A bitmask consisting of one or more of the following constants: `CURLSSH_AUTH_PUBLICKEY`, `CURLSSH_AUTH_PASSWORD`, `CURLSSH_AUTH_HOST`, `CURLSSH_AUTH_KEYBOARD`, `CURLSSH_AUTH_AGENT`, `CURLSSH_AUTH_ANY`. Defaults to `CURLSSH_AUTH_ANY`. Available as of cURL 7.16.1.
`CURLOPT_SSH_COMPRESSION` (int) | `true` to enable, `false` to disable built-in SSH compression. Note that the server can disregard this request. Defaults to `false`. Available as of PHP 7.3.0 and cURL 7.56.0.
`CURLOPT_SSH_HOSTKEYFUNCTION` (int) | A callable that will be called when SSH host key verification is needed. The callback must have the following signature: callback( resource `$curlHandle`, int `$keyType`, string `$key`, int `$keyLength` ): int `curlHandle` The cURL handle. `keyType` One of the `CURLKHTYPE_*` key types. `key` The key to check. `keyLength` The length of the key in bytes. This callback overrides `CURLOPT_SSH_KNOWNHOSTS`. Available as of PHP 8.3.0 and cURL 7.84.0.
`CURLOPT_SSH_HOST_PUBLIC_KEY_MD5` (int) | A string containing 32 hexadecimal digits which should contain the MD5 checksum of the remote host's public key, and cURL will reject the connection to the host unless the md5sums match. This option is only for SCP and SFTP transfers. Available as of cURL 7.17.1.
`CURLOPT_SSH_HOST_PUBLIC_KEY_SHA256` (int) | A string with the base64-encoded SHA256 hash of the remote host's public key. The transfer will fail if the given hash does not match the hash the remote host provides. Available as of PHP 8.2.0 and cURL 7.80.0.
`CURLOPT_SSH_KNOWNHOSTS` (int) | Set to the filename of the known_host file to use which should use the OpenSSH file format as supported by libssh2. Available as of cURL 7.19.6.
`CURLOPT_SSH_PRIVATE_KEYFILE` (int) | The file name for a private key. If not used, cURL defaults to $HOME/.ssh/id_dsa if the HOME environment variable is set, and just `id_dsa` in the current directory if HOME is not set. If the file is password-protected, set the password with `CURLOPT_KEYPASSWD`. Available as of cURL 7.16.1.
`CURLOPT_SSH_PUBLIC_KEYFILE` (int) | The file name for a public key. If not used, cURL defaults to $HOME/.ssh/id_dsa.pub if the HOME environment variable is set, and just `id_dsa.pub` in the current directory if HOME is not set. Available as of cURL 7.16.1.
`CURLOPT_SSLCERT` (int) | The name of a file containing a PEM formatted certificate. Available as of cURL 7.1.0.
`CURLOPT_SSLCERTPASSWD` (int) | The password required to use the `CURLOPT_SSLCERT` certificate. Available as of cURL 7.1.0 and deprecated as of cURL 7.17.0.
`CURLOPT_SSLCERTTYPE` (int) | A string with the format of the certificate. Supported formats are: `PEM`, `DER`, `ENG`, `P12`. `P12` (for PKCS#12-encoded files) is available as of OpenSSL 0.9.3. Defaults to `PEM`. Available as of cURL 7.9.3.
`CURLOPT_SSLCERT_BLOB` (int) | A string with the SSL client certificate. Available as of PHP 8.1.0 and cURL 7.71.0.
`CURLOPT_SSLENGINE` (int) | The string identifier for the crypto engine of the private SSL key specified in `CURLOPT_SSLKEY`. Available as of cURL 7.9.3.
`CURLOPT_SSLENGINE_DEFAULT` (int) | The string identifier for the crypto engine used for asymmetric crypto operations. Available as of cURL 7.9.3.
`CURLOPT_SSLKEY` (int) | The name of a file containing a private SSL key. Available as of cURL 7.9.3.
`CURLOPT_SSLKEYPASSWD` (int) | The secret password needed to use the private SSL key specified in `CURLOPT_SSLKEY`. Note: Since this option contains a sensitive password, remember to keep the PHP script it is contained within safe. Available as of cURL 7.9.3 and deprecated as of cURL 7.17.0.
`CURLOPT_SSLKEYTYPE` (int) | The key type of the private SSL key specified in `CURLOPT_SSLKEY`. Supported key types are: `PEM`, `DER`, `ENG`. Defaults to `PEM`. Available as of cURL 7.9.3.
`CURLOPT_SSLKEY_BLOB` (int) | A string private key for client cert. Available as of PHP 8.1.0 and cURL 7.71.0.
`CURLOPT_SSLVERSION` (int) | One of the `CURL_SSLVERSION_*` constants. Warning It is better to not set this option and leave the defaults. As setting this to `CURL_SSLVERSION_SSLv2` or `CURL_SSLVERSION_SSLv3` is very dangerous, given the known vulnerabilities in SSLv2 and SSLv3. Defaults to `CURL_SSLVERSION_DEFAULT`. Available as of cURL 7.1.0.
`CURLOPT_SSL_CIPHER_LIST` (int) | A colon-separated string of ciphers to use for the TLS 1.2 (1.1, 1.0) connection. Available as of cURL 7.9.
`CURLOPT_SSL_EC_CURVES` (int) | A colon delimited list of elliptic curve algorithms. For example, `X25519:P-521` is a valid list of two elliptic curves. This option defines the client's key exchange algorithms in the SSL handshake, if the SSL backend cURL is built to use supports it. Available as of PHP 8.2.0 and cURL 7.73.0.
`CURLOPT_SSL_ENABLE_ALPN` (int) | `false` to disable ALPN in the SSL handshake (if the SSL backend cURL is built to use supports it), which can be used to negotiate http2. Available as of PHP 7.0.7 and cURL 7.36.0.
`CURLOPT_SSL_ENABLE_NPN` (int) | `false` to disable NPN in the SSL handshake (if the SSL backend cURL is built to use supports it), which can be used to negotiate http2. Available as of PHP 7.0.7 and cURL 7.36.0, and deprecated as of cURL 7.86.0.
`CURLOPT_SSL_FALSESTART` (int) | `true` to enable and `false` to disable TLS false start which is a mode where a TLS client starts sending application data before verifying the server's `Finished` message. Available as of PHP 7.0.7 and cURL 7.42.0.
`CURLOPT_SSL_OPTIONS` (int) | Set SSL behavior options, which is a bitmask of the `CURLSSLOPT_*` constants. Defaults to none of the bits being set. Available as of PHP 7.0.7. and cURL 7.25.0.
`CURLOPT_SSL_SESSIONID_CACHE` (int) | Set to `0` to disable and `1` to enable SSL session-ID caching. By default all transfers are done using the cache enabled. Available as of cURL 7.16.0.
`CURLOPT_SSL_VERIFYHOST` (int) | `2` to verify that a Common Name field or a Subject Alternate Name field in the SSL peer certificate matches the provided hostname. `0` to not check the names. `1` should not be used. In production environments the value of this option should be kept at `2` (default value). Support for value `1` removed in cURL 7.28.1. Available as of cURL 7.8.1.
`CURLOPT_SSL_VERIFYPEER` (int) | `false` to stop cURL from verifying the peer's certificate. Alternate certificates to verify against can be specified with the `CURLOPT_CAINFO` option or a certificate directory can be specified with the `CURLOPT_CAPATH` option. Defaults to `true` as of cURL 7.10. Default bundle of CA certificates installed as of cURL 7.10. Available as of cURL 7.4.2.
`CURLOPT_SSL_VERIFYSTATUS` (int) | `true` to enable and `false` to disable verification of the certificate's status. Available as of PHP 7.0.7 and cURL 7.41.0.
`CURLOPT_STDERR` (int) | Accepts a file handle resource pointing to an alternative location to output errors to instead of `STDERR`. Available as of cURL 7.1.0.
`CURLOPT_STREAM_WEIGHT` (int) | Set the numerical stream weight (a number between `1` and `256`). Available as of PHP 7.0.7 and cURL 7.46.0.
`CURLOPT_SUPPRESS_CONNECT_HEADERS` (int) | `true` to suppress proxy CONNECT response headers from the user callback functions `CURLOPT_HEADERFUNCTION` and `CURLOPT_WRITEFUNCTION`, when `CURLOPT_HTTPPROXYTUNNEL` is used and a CONNECT request is made. Defaults to `false`. Available as of PHP 7.3.0 and cURL 7.54.0.
`CURLOPT_TCP_FASTOPEN` (int) | `true` to enable and `false` to disable TCP Fast Open. Available as of PHP 7.0.7 and cURL 7.49.0.
`CURLOPT_TCP_KEEPALIVE` (int) | If set to `1`, TCP keepalive probes will be sent. The delay and frequency of these probes can be controlled by the `CURLOPT_TCP_KEEPIDLE` and `CURLOPT_TCP_KEEPINTVL` options, provided the operating system supports them. If set to `0` (default) keepalive probes are disabled. The maximum number of probes can be set with the `CURLOPT_TCP_KEEPCNT` option. Available as of cURL 7.25.0.
`CURLOPT_TCP_KEEPIDLE` (int) | Sets the delay, in seconds, that the operating system will wait while the connection is idle before sending keepalive probes, if `CURLOPT_TCP_KEEPALIVE` is enabled. Not all operating systems support this option. The default is `60`. Available as of cURL 7.25.0.
`CURLOPT_TCP_KEEPINTVL` (int) | Sets the interval, in seconds, that the operating system will wait between sending keepalive probes, if `CURLOPT_TCP_KEEPALIVE` is enabled. Not all operating systems support this option. The default is `60`. Available as of cURL 7.25.0.
`CURLOPT_TCP_KEEPCNT` (int) | Sets the maximum number of TCP keep-alive probes. The default is `9`. Available as of PHP 8.4.0 and cURL 8.9.0.
`CURLOPT_TCP_NODELAY` (int) | `true` to disable TCP's Nagle algorithm, which tries to minimize the number of small packets on the network. Defaults to `true`. Available as of cURL 7.11.2.
`CURLOPT_TELNETOPTIONS` (int) | Set an array of strings to pass to the telnet negotiations. The variables should be in the format `<option=value>`. cURL supports the options `TTYPE`, `XDISPLOC` and `NEW_ENV`. Available as of cURL 7.7.0.
`CURLOPT_TFTP_BLKSIZE` (int) | Set the blocksize to use for TFTP data transmission. Valid range is `8`-`65464` bytes. The default of `512` bytes is used if this option is not specified. The specified block size is only used if supported by the remote server. If the server does not return an option acknowledgment or returns an option acknowledgment with no block size, the default of `512` bytes is used. Available as of cURL 7.19.4.
`CURLOPT_TFTP_NO_OPTIONS` (int) | `true` to not send TFTP options requests. Defaults to `false`. Available as of PHP 7.0.7 and cURL 7.48.0.
`CURLOPT_TIMECONDITION` (int) | Set how `CURLOPT_TIMEVALUE` is treated. Use `CURL_TIMECOND_IFMODSINCE` to return the page only if it has been modified since the time specified in `CURLOPT_TIMEVALUE`. If it hasn't been modified, a `304 Not Modified` header will be returned assuming `CURLOPT_HEADER` is `true`. Use `CURL_TIMECOND_IFUNMODSINCE` for the reverse effect. Use `CURL_TIMECOND_NONE` to ignore `CURLOPT_TIMEVALUE` and always return the page. `CURL_TIMECOND_NONE` is the default. Prior to cURL 7.46.0 the default was `CURL_TIMECOND_IFMODSINCE`. Available as of cURL 7.1.0.
`CURLOPT_TIMEOUT` (int) | The maximum number of seconds to allow cURL functions to execute. Defaults to `0`, meaning that functions never time out during transfer. Available as of cURL 7.1.0.
`CURLOPT_TIMEOUT_MS` (int) | The maximum number of milliseconds to allow cURL functions to execute. If cURL is built to use the standard system name resolver, that portion of the connect will still use full-second resolution for timeouts with a minimum timeout allowed of one second. Defaults to `0`, meaning that functions never time out during transfer. Available as of cURL 7.16.2.
`CURLOPT_TIMEVALUE` (int) | The time in seconds since January 1st, 1970. The time will be used by `CURLOPT_TIMECONDITION`. Defaults to `0`. Available as of cURL 7.1.0.
`CURLOPT_TIMEVALUE_LARGE` (int) | The time in seconds since January 1st, 1970. The time will be used by `CURLOPT_TIMECONDITION`. Defaults to zero. The difference between this option and `CURLOPT_TIMEVALUE` is the type of the argument. On systems where 'long' is only 32 bit wide, this option has to be used to set dates beyond the year 2038. Available as of PHP 7.3.0 and cURL 7.59.0.
`CURLOPT_TLS13_CIPHERS` (int) | A string with a colon-separated list of ciphers to use for the connection to the TLS 1.3 connection. This option is currently used only when cURL is built to use OpenSSL 1.1.1 or later. When using a different SSL backend the TLS 1.3 cipher suites can be set with the `CURLOPT_SSL_CIPHER_LIST` option. Available as of PHP 7.3.0 and cURL 7.61.0.
`CURLOPT_TLSAUTH_PASSWORD` (int) | Set a password to use for the TLS authentication method specified with the `CURLOPT_TLSAUTH_TYPE` option. Requires that the `CURLOPT_TLSAUTH_USERNAME` option also be set. This feature relies on TLS SRP which does not work with TLS 1.3. Available as of cURL 7.21.4.
`CURLOPT_TLSAUTH_TYPE` (int) | Set a string with the method of the TLS authentication. Supported method is `SRP` (TLS Secure Remote Password authentication). Available as of cURL 7.21.4.
`CURLOPT_TLSAUTH_USERNAME` (int) | Set a string with the username to use for the TLS authentication method specified with the `CURLOPT_TLSAUTH_TYPE` option. Requires that the `CURLOPT_TLSAUTH_PASSWORD` option also be set. This feature relies on TLS SRP which does not work with TLS 1.3. Available as of cURL 7.21.4.
`CURLOPT_TRANSFER_ENCODING` (int) | Set to `1` to enable and `0` to disable requesting compressed `Transfer Encoding` in the outgoing HTTP request. If the server responds with a compressed `Transfer Encoding`, cURL will automatically uncompress it on reception. Defaults to `0`. Available as of cURL 7.21.6.
`CURLOPT_TRANSFERTEXT` (int) | `true` to use ASCII mode for FTP transfers. For LDAP, it retrieves data in plain text instead of HTML. On Windows systems, it will not set `STDOUT` to binary mode. Defaults to `false`. Available as of cURL 7.1.1.
`CURLOPT_UNIX_SOCKET_PATH` (int) | Enables the use of Unix domain sockets as connection endpoint and sets the path to the given string. Set to `null` to disable. Defaults to `null`. Available as of PHP 7.0.7 and cURL 7.40.0.
`CURLOPT_UNRESTRICTED_AUTH` (int) | `true` to keep sending the username and password when following locations (using `CURLOPT_FOLLOWLOCATION`), even when the hostname has changed. Defaults to `false`. Available as of cURL 7.10.4.
`CURLOPT_UPKEEP_INTERVAL_MS` (int) | Some protocols have "connection upkeep" mechanisms. These mechanisms usually send some traffic on existing connections in order to keep them alive. This option defines the connection upkeep interval. Currently, the only protocol with a connection upkeep mechanism is HTTP/2. When the connection upkeep interval is exceeded, an HTTP/2 PING frame is sent on the connection. Defaults to `CURL_UPKEEP_INTERVAL_DEFAULT` which is currently `60` seconds. Available as of PHP 8.2.0 and cURL 7.62.0.
`CURLOPT_UPLOAD` (int) | `true` to prepare for and perform an upload. Defaults to `false`. Available as of cURL 7.1.0.
`CURLOPT_UPLOAD_BUFFERSIZE` (int) | Preferred buffer size in bytes for the cURL upload buffer. The upload buffer size by default is 64 kilobytes. The maximum buffer size allowed to be set is 2 megabytes. The minimum buffer size allowed to be set is 16 kilobytes. Available as of PHP 8.2.0 and cURL 7.62.0.
`CURLOPT_URL` (int) | The URL to fetch. This can also be set when initializing a session with curl_init(). Available as of cURL 7.1.0.
`CURLOPT_USE_SSL` (int) | Sets the desired level of SSL/TLS for the transfer when using FTP, SMTP, POP3, IMAP, etc. These are all protocols that start out plain text and get "upgraded" to SSL using the STARTTLS command. Set to one of the `CURLUSESSL_*` constants. Available as of cURL 7.17.0.
`CURLOPT_USERAGENT` (int) | The contents of the `User-Agent:` header to be used in a HTTP request. Available as of cURL 7.1.0.
`CURLOPT_USERNAME` (int) | The user name to use in authentication. Available as of cURL 7.19.1.
`CURLOPT_USERPWD` (int) | A username and password formatted as `[username]:[password]` to use for the connection. Available as cURL 7.1.0.
`CURLOPT_VERBOSE` (int) | `true` to output verbose information. Writes output to `STDERR`, or the file specified using `CURLOPT_STDERR`. Defaults to `false`. Available as of cURL 7.1.0.
`CURLOPT_WILDCARDMATCH` (int) | Set to `1` to transfer multiple files according to a filename pattern. The pattern can be specified as part of the `CURLOPT_URL` option, using an fnmatch-like pattern (Shell Pattern Matching) in the last part of URL (filename). Available as of cURL 7.21.0.
`CURLOPT_WRITEFUNCTION` (int) | A callable with the following signature: callback(resource `$curlHandle`, string `$data`): int `curlHandle` The cURL handle. `data` The data to be written. The data must be saved by the callback and the callback must return the exact number of bytes written or the transfer will be aborted with an error. Available as of cURL 7.1.0.
`CURLOPT_WRITEHEADER` (int) | Accepts a file handle resource to the file that the header part of the transfer is written to. Available as of cURL 7.1.0.
`CURLOPT_WS_OPTIONS` (int) | Accepts a bitmask setting WebSocket behavior options. The only available option is `CURLWS_RAW_MODE`. Defaults to `0`. Available as of PHP 8.3.0 and cURL 7.86.0.
`CURLOPT_XFERINFOFUNCTION` (int) | A callable with the following signature: callback( resource `$curlHandle`, int `$bytesToDownload`, int `$bytesDownloaded`, int `$bytesToUpload`, int `$bytesUploaded` ): int `curlHandle` The cURL handle. `bytesToDownload` The total number of bytes expected to be downloaded in this transfer. `bytesDownloaded` The number of bytes downloaded so far. `bytesToUpload` The total number of bytes expected to be uploaded in this transfer. `bytesUploaded` The number of bytes uploaded so far. Return `1` to abort the transfer and set a `CURLE_ABORTED_BY_CALLBACK` error. Available as of PHP 8.2.0 and cURL 7.32.0.
`CURLOPT_SERVER_RESPONSE_TIMEOUT` (int) | A timeout in seconds cURL will wait for a response from an FTP, SFTP, IMAP, SCP, SMTP, or a POP3 server. This option replaces the existing `CURLOPT_FTP_RESPONSE_TIMEOUT` option which is deprecated in cURL 7.85.0. Available as of PHP 8.4.0.
`CURLOPT_XOAUTH2_BEARER` (int) | Specifies the OAuth 2.0 access token. Set to `null` to disable. Defaults to `null`. Available as of PHP 7.0.7 and cURL 7.33.0.
`CURLOPT_PREREQFUNCTION` (int) | A callable with the following signature that gets called after the connection is established, but before the request payload (for example, the GET/POST/DELETE request of an HTTP connection) is sent, and can be used to abort or allow the connection depending on the source and destination IP address and port numbers: callback( CurlHandle `$curlHandle`, string `$destination_ip`, string `$local_ip`, int `$destination_port`, int `$local_port` ): int `curlHandle` The cURL handle. `destination_ip` The primary IP of the remote server established with this connection. For FTP, this is the IP for the control connection. IPv6 addresses are represented without surrounding brackets. `local_ip` The originating IP for this connection. IPv6 addresses are represented without surrounding brackets. `destination_port` The primary port number on the remote server established with this connection. For FTP, this is the port for the control connection. This can be a TCP or a UDP port number depending on the protocol. `local_port` The originating port number for this connection. This can be a TCP or a UDP port number depending on the protocol. Return `CURL_PREREQFUNC_OK` to allow the request, or `CURL_PREREQFUNC_ABORT` to abort the transfer. Available as of PHP 8.4.0 and cURL 7.80.0.
  `CURLOPT_DEBUGFUNCTION` (int) | Available as of PHP 8.4.0. This option requires `CURLOPT_VERBOSE` option enabled. A callable to replace the standard cURL verbose output. This callback gets called during various stages of the request with verbose debug information. The callback should match the following signature: callback(CurlHandle `$curlHandle`, int `$type`, string `$data`): void `curlHandle` The cURL handle. `type` One of the following constants indicating the type of the `data` value:
  Constants | Description
  --- | ---
  `CURLINFO_TEXT` (int) | Informational text.
  `CURLINFO_HEADER_IN` (int) | Header (or header-like) data received from the peer.
  `CURLINFO_HEADER_OUT` (int) | Header (or header-like) data sent to the peer.
  `CURLINFO_DATA_IN` (int) | Unprocessed protocol data received from the peer. Even if the data is encoded or compressed, it is not provided decoded nor decompressed to this callback.
  `CURLINFO_DATA_OUT` (int) | Protocol data sent to the peer.
  `CURLINFO_SSL_DATA_IN` (int) | SSL/TLS (binary) data received from the peer.
  `CURLINFO_SSL_DATA_OUT` (int) | SSL/TLS (binary) data sent to the peer.
`data` Verbose debug data of the type indicate by the `type` parameter.

Constants | Description
--- | ---
curl_share_setopt()
`CURL_LOCK_DATA_CONNECT` (int) | Shares/unshares the connection cache. Available as of PHP 7.3.0 and cURL 7.10.3.
`CURL_LOCK_DATA_COOKIE` (int) | Shares/unshares cookie data. Available as of cURL 7.10.3.
`CURL_LOCK_DATA_DNS` (int) | Shares/unshares DNS cache. Note that when you use cURL multi handles, all handles added to the same multi handle will share DNS cache by default. Available as of cURL 7.10.3.
`CURL_LOCK_DATA_PSL` (int) | Shares/unshares the Public Suffix List. Available as of PHP 7.3.0 and cURL 7.61.0.
`CURL_LOCK_DATA_SSL_SESSION` (int) | Shares/unshares SSL session IDs, reducing the time spent on the SSL handshake when reconnecting to the same server. Note that SSL session IDs are reused within the same handle by default. Available as of cURL 7.10.3.
`CURLSHOPT_NONE` (int) | Available as of cURL 7.10.3.
`CURLSHOPT_SHARE` (int) | Specifies a type of data that should be shared. Available as of cURL 7.10.3.
`CURLSHOPT_UNSHARE` (int) | Specifies a type of data that will be no longer shared. Available as of cURL 7.10.3.

Constants | Description
--- | ---
curl_getinfo()
`CURLINFO_APPCONNECT_TIME` (int) | Time in seconds it took from the start until the SSL/SSH connect/handshake to the remote host was completed
`CURLINFO_APPCONNECT_TIME_T` (int) | Time, in microseconds, it took from the start until the SSL/SSH connect/handshake to the remote host was completed. Available as of PHP 7.3.0 and cURL 7.61.0
`CURLINFO_CAINFO` (int) | Default built-in CA certificate path. Available as of PHP 8.3.0 and cURL 7.84.0
`CURLINFO_CAPATH` (int) | Default built-in CA path string. Available as of PHP 8.3.0 and cURL 7.84.0
`CURLINFO_CERTINFO` (int) | TLS certificate chain
`CURLINFO_CONDITION_UNMET` (int) | Info on unmet time conditional
`CURLINFO_CONNECT_TIME` (int) | Time in seconds it took to establish the connection
`CURLINFO_CONNECT_TIME_T` (int) | Total time taken, in microseconds, from the start until the connection to the remote host (or proxy) was completed. Available as of PHP 7.3.0 and cURL 7.61.0
`CURLINFO_CONTENT_LENGTH_DOWNLOAD` (int) | Content length of download, read from Content-Length: field
`CURLINFO_CONTENT_LENGTH_DOWNLOAD_T` (int) | The content-length of the download. This is the value read from the Content-Length: field. -1 if the size isn't known. Available as of PHP 7.3.0 and cURL 7.55.0
`CURLINFO_CONTENT_LENGTH_UPLOAD` (int) | Specified size of upload
`CURLINFO_CONTENT_LENGTH_UPLOAD_T` (int) | The specified size of the upload. -1 if the size isn't known. Available as of PHP 7.3.0 and cURL 7.55.0
`CURLINFO_CONTENT_TYPE` (int) | `Content-Type` of the requested document. NULL indicates server did not send valid `Content-Type` header
`CURLINFO_COOKIELIST` (int) | All known cookies
`CURLINFO_EFFECTIVE_METHOD` (int) | Get the last used HTTP method.
`CURLINFO_EFFECTIVE_URL` (int) | Last effective URL
`CURLINFO_FILETIME` (int) | Remote time of the retrieved document, with the `CURLOPT_FILETIME` enabled; if -1 is returned the time of the document is unknown
`CURLINFO_FILETIME_T` (int) | Remote time of the retrieved document (as Unix timestamp), an alternative to `CURLINFO_FILETIME` to allow systems with 32 bit long variables to extract dates outside of the 32bit timestamp range. Available as of PHP 7.3.0 and cURL 7.59.0
`CURLINFO_FTP_ENTRY_PATH` (int) | Entry path in FTP server
`CURLINFO_HEADER_OUT` (int) | The request string sent. For this to work, add the `CURLINFO_HEADER_OUT` option to the handle by calling curl_setopt()
`CURLINFO_HEADER_SIZE` (int) | Total size of all headers received
`CURLINFO_HTTPAUTH_AVAIL` (int) | Bitmask indicating the authentication method(s) available according to the previous response
`CURLINFO_HTTP_CODE` (int) | The last response code. As of cURL 7.10.8, this is a legacy alias of `CURLINFO_RESPONSE_CODE`.
`CURLINFO_HTTP_CONNECTCODE` (int) | The CONNECT response code
`CURLINFO_HTTP_VERSION` (int) | The version used in the last HTTP connection. The return value will be one of the defined `CURL_HTTP_VERSION_*` constants or 0 if the version can't be determined. Available as of PHP 7.3.0 and cURL 7.50.0
`CURLINFO_LASTONE` (int) | The last enum value in the underlying `CURLINFO` enum in `libcurl`.
`CURLINFO_LOCAL_IP` (int) | Local (source) IP address of the most recent connection
`CURLINFO_LOCAL_PORT` (int) | Local (source) port of the most recent connection
`CURLINFO_NAMELOOKUP_TIME` (int) | Time in seconds until name resolving was complete
`CURLINFO_NAMELOOKUP_TIME_T` (int) | Time in microseconds from the start until the name resolving was completed. Available as of PHP 7.3.0 and cURL 7.61.0
`CURLINFO_NUM_CONNECTS` (int) | Number of connections curl had to create to achieve the previous transfer
`CURLINFO_OS_ERRNO` (int) | Errno from a connect failure. The number is OS and system specific.
`CURLINFO_PRETRANSFER_TIME` (int) | Time in seconds from start until just before file transfer begins
`CURLINFO_PRETRANSFER_TIME_T` (int) | Time taken from the start until the file transfer is just about to begin, in microseconds. Available as of PHP 7.3.0 and cURL 7.61.0
`CURLINFO_PRIMARY_IP` (int) | IP address of the most recent connection
`CURLINFO_PRIMARY_PORT` (int) | Destination port of the most recent connection
`CURLINFO_PRIVATE` (int) | Private data associated with this cURL handle, previously set with the `CURLOPT_PRIVATE` option of curl_setopt()
`CURLINFO_PROTOCOL` (int) | The protocol used in the last HTTP connection. The returned value will be exactly one of the `CURLPROTO_*` values. Available as of PHP 7.3.0 and cURL 7.52.0
`CURLINFO_PROXYAUTH_AVAIL` (int) | Bitmask indicating the proxy authentication method(s) available according to the previous response
`CURLINFO_PROXY_ERROR` (int) | The detailed (SOCKS) proxy error code when the most recent transfer returned a `CURLE_PROXY` error. The returned value will be exactly one of the `CURLPX_*` values. The error code will be `CURLPX_OK` if no response code was available. Available as of PHP 8.2.0 and cURL 7.73.0
`CURLINFO_PROXY_SSL_VERIFYRESULT` (int) | The result of the certificate verification that was requested (using the `CURLOPT_PROXY_SSL_VERIFYPEER` option). Only used for HTTPS proxies. Available as of PHP 7.3.0 and cURL 7.52.0
`CURLINFO_REDIRECT_COUNT` (int) | Number of redirects, with the `CURLOPT_FOLLOWLOCATION` option enabled
`CURLINFO_REDIRECT_TIME` (int) | Time in seconds of all redirection steps before final transaction was started, with the `CURLOPT_FOLLOWLOCATION` option enabled
`CURLINFO_REDIRECT_TIME_T` (int) | Total time, in microseconds, it took for all redirection steps include name lookup, connect, pretransfer and transfer before final transaction was started. Available as of PHP 7.3.0 and cURL 7.61.0
`CURLINFO_REDIRECT_URL` (int) | With the `CURLOPT_FOLLOWLOCATION` option disabled: redirect URL found in the last transaction, that should be requested manually next. With the `CURLOPT_FOLLOWLOCATION` option enabled: this is empty. The redirect URL in this case is available in `CURLINFO_EFFECTIVE_URL`
`CURLINFO_REFERER` (int) | The `Referer` header. Available as of PHP 8.2.0 and cURL 7.76.0
`CURLINFO_REQUEST_SIZE` (int) | Total size of issued requests, currently only for HTTP requests
`CURLINFO_RESPONSE_CODE` (int) | The last response code. Available as of cURL 7.10.8
`CURLINFO_RETRY_AFTER` (int) | The information from the `Retry-After` header, or zero if there was no valid header. Available as of PHP 8.2.0 and cURL 7.66.0
`CURLINFO_RTSP_CLIENT_CSEQ` (int) | Next RTSP client CSeq
`CURLINFO_RTSP_CSEQ_RECV` (int) | Recently received CSeq
`CURLINFO_RTSP_SERVER_CSEQ` (int) | Next RTSP server CSeq
`CURLINFO_RTSP_SESSION_ID` (int) | RTSP session ID
`CURLINFO_SCHEME` (int) | The URL scheme used for the most recent connection. Available as of PHP 7.3.0 and cURL 7.52.0
`CURLINFO_SIZE_DOWNLOAD` (int) | Total number of bytes downloaded
`CURLINFO_SIZE_DOWNLOAD_T` (int) | Total number of bytes that were downloaded. The number is only for the latest transfer and will be reset again for each new transfer. Available as of PHP 7.3.0 and cURL 7.50.0
`CURLINFO_SIZE_UPLOAD` (int) | Total number of bytes uploaded
`CURLINFO_SIZE_UPLOAD_T` (int) | Total number of bytes that were uploaded. Available as of PHP 7.3.0 and cURL 7.50.0
`CURLINFO_SPEED_DOWNLOAD` (int) | Average download speed
`CURLINFO_SPEED_DOWNLOAD_T` (int) | The average download speed in bytes/second that curl measured for the complete download. Available as of PHP 7.3.0 and cURL 7.50.0
`CURLINFO_SPEED_UPLOAD` (int) | Average upload speed
`CURLINFO_SPEED_UPLOAD_T` (int) | The average upload speed in bytes/second that curl measured for the complete upload. Available as of PHP 7.3.0 and cURL 7.50.0
`CURLINFO_SSL_ENGINES` (int) | OpenSSL crypto-engines supported
`CURLINFO_SSL_VERIFYRESULT` (int) | Result of SSL certification verification requested by setting `CURLOPT_SSL_VERIFYPEER`
`CURLINFO_STARTTRANSFER_TIME` (int) | Time in seconds until the first byte is about to be transferred
`CURLINFO_STARTTRANSFER_TIME_T` (int) | Time, in microseconds, it took from the start until the first byte is received. Available as of PHP 7.3.0 and cURL 7.61.0
`CURLINFO_TOTAL_TIME` (int) | Total transaction time in seconds for last transfer
`CURLINFO_TOTAL_TIME_T` (int) | Total time in microseconds for the previous transfer, including name resolving, TCP connect etc. Available as of PHP 7.3.0 and cURL 7.61.0
`CURLINFO_POSTTRANSFER_TIME_T` (int) | Time it took from the start until the last byte is sent, in microseconds. Available as of PHP 8.4.0 and cURL 8.10.0

Constants | Description
--- | ---
curl_multi_setopt()
`CURLMOPT_CHUNK_LENGTH_PENALTY_SIZE` (int) | Specifies the chunk length threshold for pipelining in bytes. Available as of PHP 7.0.7 and cURL 7.30.0
`CURLMOPT_CONTENT_LENGTH_PENALTY_SIZE` (int) | Specifies the size threshold for pipelining penalty in bytes. Available as of PHP 7.0.7 and cURL 7.30.0
`CURLMOPT_MAXCONNECTS` (int) | Specifies the maximum amount of simultaneously open connections that libcurl may cache. By default the size will be enlarged to fit four times the number of handles added via curl_multi_add_handle(). When the cache is full, curl closes the oldest one in the cache to prevent the number of open connections from increasing. Available as of cURL 7.16.3.
`CURLMOPT_MAX_CONCURRENT_STREAMS` (int) | Specifies the maximum number of concurrent streams for connections that cURL should support on connections using HTTP/2. Valid values range from `1` to `2147483647` (`2^31 - 1`). The value passed here would be honored based on other system resources properties. Default is `100`. Available as of PHP 8.2.0 and cURL 7.67.0.
`CURLMOPT_MAX_HOST_CONNECTIONS` (int) | Specifies the maximum number of connections to a single host. Available as of PHP 7.0.7 and cURL 7.30.0
`CURLMOPT_MAX_PIPELINE_LENGTH` (int) | Specifies the maximum number of requests in a pipeline. Available as of PHP 7.0.7 and cURL 7.30.0
`CURLMOPT_MAX_TOTAL_CONNECTIONS` (int) | Specifies the maximum number of simultaneously open connections. Available as of PHP 7.0.7 and cURL 7.30.0
`CURLMOPT_PIPELINING` (int) | Pass 1 to enable or 0 to disable. Enabling pipelining on a multi handle will make it attempt to perform HTTP Pipelining as far as possible for transfers using this handle. This means that adding a second request that can use an already existing connection will "pipe" the second request on the same connection. As of cURL 7.43.0, the value is a bitmask, and passing 2 will try to multiplex the new transfer over an existing HTTP/2 connection. Passing 3 instructs cURL to ask for pipelining and multiplexing independently of each other. As of cURL 7.62.0, setting the pipelining bit has no effect. Instead of integer literals, the CURLPIPE_* constants can also be used. Available as of cURL 7.16.0.
`CURLMOPT_PUSHFUNCTION` (int) | Pass a callable that will be registered to handle server pushes and should have the following signature: pushfunction(resource `$parent_ch`, resource `$pushed_ch`, array `$headers`): int `parent_ch` The parent cURL handle (the request the client made). `pushed_ch` A new cURL handle for the pushed request. `headers` The push promise headers. The push function is supposed to return either `CURL_PUSH_OK` if it can handle the push, or `CURL_PUSH_DENY` to reject it. Available as of PHP 7.1.0 and cURL 7.44.0

Constants | Description
--- | ---
cURL protocol constants
`CURLPROTO_ALL` (int) | Available as of cURL 7.19.4.
`CURLPROTO_DICT` (int) | Available as of cURL 7.19.4.
`CURLPROTO_FILE` (int) | Available as of cURL 7.19.4.
`CURLPROTO_FTP` (int) | Available as of cURL 7.19.4.
`CURLPROTO_FTPS` (int) | Available as of cURL 7.19.4.
`CURLPROTO_GOPHER` (int) | Available as of cURL 7.21.2.
`CURLPROTO_HTTP` (int) | Available as of cURL 7.19.4.
`CURLPROTO_HTTPS` (int) | Available as of cURL 7.19.4.
`CURLPROTO_IMAP` (int) | Available as of cURL 7.20.0.
`CURLPROTO_IMAPS` (int) | Available as of cURL 7.20.0.
`CURLPROTO_LDAP` (int) | Available as of cURL 7.19.4.
`CURLPROTO_LDAPS` (int) | Available as of cURL 7.19.4.
`CURLPROTO_MQTT` (int) | Available as of PHP 8.2.0 and cURL 7.71.0.
`CURLPROTO_POP3` (int) | Available as of cURL 7.20.0.
`CURLPROTO_POP3S` (int) | Available as of cURL 7.20.0.
`CURLPROTO_RTMP` (int) | Available as of cURL 7.21.0.
`CURLPROTO_RTMPE` (int) | Available as of cURL 7.21.0.
`CURLPROTO_RTMPS` (int) | Available as of cURL 7.21.0.
`CURLPROTO_RTMPT` (int) | Available as of cURL 7.21.0.
`CURLPROTO_RTMPTE` (int) | Available as of cURL 7.21.0.
`CURLPROTO_RTMPTS` (int) | Available as of cURL 7.21.0.
`CURLPROTO_RTSP` (int) | Available as of cURL 7.20.0.
`CURLPROTO_SCP` (int) | Available as of cURL 7.19.4.
`CURLPROTO_SFTP` (int) | Available as of cURL 7.19.4.
`CURLPROTO_SMB` (int) | Available as of PHP 7.0.7 and cURL 7.40.0.
`CURLPROTO_SMBS` (int) | Available as of PHP 7.0.7 and cURL 7.40.0.
`CURLPROTO_SMTP` (int) | Available as of cURL 7.20.0.
`CURLPROTO_SMTPS` (int) | Available as of cURL 7.20.0.
`CURLPROTO_TELNET` (int) | Available as of cURL 7.19.4.
`CURLPROTO_TFTP` (int) | Available as of cURL 7.19.4.

Constants | Description
--- | ---
cURL error constants
`CURLE_ABORTED_BY_CALLBACK` (int) | Aborted by callback. A callback returned "abort" to libcurl.
`CURLE_BAD_CALLING_ORDER` (int) |
`CURLE_BAD_CONTENT_ENCODING` (int) | Unrecognized transfer encoding.
`CURLE_BAD_DOWNLOAD_RESUME` (int) | The download could not be resumed because the specified offset was out of the file boundary.
`CURLE_BAD_FUNCTION_ARGUMENT` (int) | A function was called with a bad parameter.
`CURLE_BAD_PASSWORD_ENTERED` (int) |
`CURLE_COULDNT_CONNECT` (int) | Failed to connect to host or proxy.
`CURLE_COULDNT_RESOLVE_HOST` (int) | Could not resolve host. The given remote host was not resolved.
`CURLE_COULDNT_RESOLVE_PROXY` (int) | Could not resolve proxy. The given proxy host could not be resolved.
`CURLE_FAILED_INIT` (int) | Early initialization code failed. This is likely to be an internal error or problem, or a resource problem where something fundamental could not get done at init time.
`CURLE_FILESIZE_EXCEEDED` (int) | Maximum file size exceeded.
`CURLE_FILE_COULDNT_READ_FILE` (int) | A file given with FILE:// could not be opened. Most likely because the file path does not identify an existing file or due to the lack of appropriate file permissions.
`CURLE_FTP_ACCESS_DENIED` (int) |
`CURLE_FTP_BAD_DOWNLOAD_RESUME` (int) |
`CURLE_FTP_CANT_GET_HOST` (int) | An internal failure to lookup the host used for the new connection.
`CURLE_FTP_CANT_RECONNECT` (int) |
`CURLE_FTP_COULDNT_GET_SIZE` (int) |
`CURLE_FTP_COULDNT_RETR_FILE` (int) | This was either a unexpected reply to a 'RETR' command or a zero byte transfer complete.
`CURLE_FTP_COULDNT_SET_ASCII` (int) |
`CURLE_FTP_COULDNT_SET_BINARY` (int) |
`CURLE_FTP_COULDNT_STOR_FILE` (int) |
`CURLE_FTP_COULDNT_USE_REST` (int) | The FTP REST command returned error. This should never happen if the server is sane.
`CURLE_FTP_PARTIAL_FILE` (int) |
`CURLE_FTP_PORT_FAILED` (int) | The FTP PORT command returned error. This mostly happens when a good enough address has not been specified for libcurl to use. See `CURLOPT_FTPPORT`.
`CURLE_FTP_QUOTE_ERROR` (int) |
`CURLE_FTP_SSL_FAILED` (int) |
`CURLE_FTP_USER_PASSWORD_INCORRECT` (int) |
`CURLE_FTP_WEIRD_227_FORMAT` (int) | FTP servers return a 227-line as a response to a PASV command. If libcurl fails to parse that line, this return code is passed back.
`CURLE_FTP_WEIRD_PASS_REPLY` (int) | After having sent the FTP password to the server, libcurl expects a proper reply. This error code indicates that an unexpected code was returned.
`CURLE_FTP_WEIRD_PASV_REPLY` (int) | libcurl failed to get a sensible result back from the server as a response to either a PASV or a EPSV command. The server is flawed.
`CURLE_FTP_WEIRD_SERVER_REPLY` (int) | The server sent data libcurl could not parse. This error code is known as `CURLE_WEIRD_SERVER_REPLY` as of cURL 7.51.0.
`CURLE_FTP_WEIRD_USER_REPLY` (int) |
`CURLE_FTP_WRITE_ERROR` (int) |
`CURLE_FUNCTION_NOT_FOUND` (int) | Function not found. A required zlib function was not found.
`CURLE_GOT_NOTHING` (int) | Nothing was returned from the server, and under the circumstances, getting nothing is considered an error.
`CURLE_HTTP_NOT_FOUND` (int) |
`CURLE_HTTP_PORT_FAILED` (int) |
`CURLE_HTTP_POST_ERROR` (int) | This is an odd error that mainly occurs due to internal confusion.
`CURLE_HTTP_RANGE_ERROR` (int) |
`CURLE_HTTP_RETURNED_ERROR` (int) | This is returned if `CURLOPT_FAILONERROR` is set `true` and the HTTP server returns an error code that is greater than or equal to 400.
`CURLE_LDAP_CANNOT_BIND` (int) | LDAP cannot bind. LDAP bind operation failed.
`CURLE_LDAP_INVALID_URL` (int) |
`CURLE_LDAP_SEARCH_FAILED` (int) | LDAP search failed.
`CURLE_LIBRARY_NOT_FOUND` (int) |
`CURLE_MALFORMAT_USER` (int) |
`CURLE_OBSOLETE` (int) |
`CURLE_OK` (int) | All fine. Proceed as usual.
`CURLE_OPERATION_TIMEDOUT` (int) | Operation timeout. The specified time-out period was reached according to the conditions.
`CURLE_OPERATION_TIMEOUTED` (int) |
`CURLE_OUT_OF_MEMORY` (int) | A memory allocation request failed.
`CURLE_PARTIAL_FILE` (int) | A file transfer was shorter or larger than expected. This happens when the server first reports an expected transfer size, and then delivers data that does not match the previously given size.
`CURLE_PROXY` (int) | Proxy handshake error. `CURLINFO_PROXY_ERROR` provides extra details on the specific problem. Available as of PHP 8.2.0 and cURL 7.73.0
`CURLE_READ_ERROR` (int) | There was a problem reading a local file or an error returned by the read callback.
`CURLE_RECV_ERROR` (int) | Failure with receiving network data.
`CURLE_SEND_ERROR` (int) | Failed sending network data.
`CURLE_SHARE_IN_USE` (int) |
`CURLE_SSH` (int) | An unspecified error occurred during the SSH session. Available as of cURL 7.16.1.
`CURLE_SSL_CACERT` (int) |
`CURLE_SSL_CACERT_BADFILE` (int) | Problem with reading the SSL CA cert.
`CURLE_SSL_CERTPROBLEM` (int) | Problem with the local client certificate.
`CURLE_SSL_CIPHER` (int) | Could not use specified cipher.
`CURLE_SSL_CONNECT_ERROR` (int) | A problem occurred somewhere in the SSL/TLS handshake. Reading the message in the error buffer provides more details on the problem. Could be certificates (file formats, paths, permissions), passwords, and others.
`CURLE_SSL_ENGINE_NOTFOUND` (int) | The specified crypto engine was not found.
`CURLE_SSL_ENGINE_SETFAILED` (int) | Failed setting the selected SSL crypto engine as default.
`CURLE_SSL_PEER_CERTIFICATE` (int) |
`CURLE_SSL_PINNEDPUBKEYNOTMATCH` (int) | Failed to match the pinned key specified with `CURLOPT_PINNEDPUBLICKEY`.
`CURLE_TELNET_OPTION_SYNTAX` (int) |
`CURLE_TOO_MANY_REDIRECTS` (int) | Too many redirects. When following redirects, libcurl hit the maximum amount. The limit can be set with `CURLOPT_MAXREDIRS`.
`CURLE_UNKNOWN_TELNET_OPTION` (int) |
`CURLE_UNSUPPORTED_PROTOCOL` (int) | The URL passed to libcurl used a protocol that libcurl does not support. The issue might be a compile-time option that was not used, a misspelled protocol string or just a protocol libcurl has no code for.
`CURLE_URL_MALFORMAT` (int) | The URL was not properly formatted.
`CURLE_URL_MALFORMAT_USER` (int) |
`CURLE_WEIRD_SERVER_REPLY` (int) | The server sent data libcurl could not parse. This error code was known as `CURLE_FTP_WEIRD_SERVER_REPLY` before cURL 7.51.0. Available as of PHP 7.3.0 and cURL 7.51.0
`CURLE_WRITE_ERROR` (int) | An error occurred when writing received data to a local file, or an error was returned to libcurl from a write callback.

Constants | Description
--- | ---
curl_multi_* status constants
`CURLM_ADDED_ALREADY` (int) | An easy handle already added to a multi handle was attempted to get added a second time. Available as of cURL 7.32.1.
`CURLM_BAD_EASY_HANDLE` (int) | An easy handle was not good/valid. It could mean that it is not an easy handle at all, or possibly that the handle already is in use by this or another multi handle. Available as of cURL 7.9.6.
`CURLM_BAD_HANDLE` (int) | The passed-in handle is not a valid multi handle. Available as of cURL 7.9.6.
`CURLM_CALL_MULTI_PERFORM` (int) | As of cURL 7.20.0, this constant is not used. Before cURL 7.20.0, this status could be returned by curl_multi_exec() when curl_multi_select() or a similar function was called before it returned any other constant. Available as of cURL 7.9.6.
`CURLM_INTERNAL_ERROR` (int) | Internal `libcurl` error. Available as of cURL 7.9.6.
`CURLM_OK` (int) | No errors. Available as of cURL 7.9.6.
`CURLM_OUT_OF_MEMORY` (int) | Ran out of memory while processing multi handles. Available as of cURL 7.9.6.

Constants | Description
--- | ---
curl_pause()
`CURLPAUSE_ALL` (int) | Pause sending and receiving data. Available as of cURL 7.18.0.
`CURLPAUSE_CONT` (int) | Unpause sending and receiving data. Available as of cURL 7.18.0.
`CURLPAUSE_RECV` (int) | Pause receiving data. Available as of cURL 7.18.0.
`CURLPAUSE_RECV_CONT` (int) | Unpause receiving data. Available as of cURL 7.18.0.
`CURLPAUSE_SEND` (int) | Pause sending data. Available as of cURL 7.18.0.
`CURLPAUSE_SEND_CONT` (int) | Unpause sending data. Available as of cURL 7.18.0.

`↑` and `↓` to navigate • `Enter` to select • `Esc` to close • `/` to open